

/**
 * Title:
 * Description:
 * Copyright:
 * Company:
 * @author Mika Vesterholm
 * @version 1.0
 */
import java.util.*;

public class Kokoelmakehys {

  public static void main(String[] args) {

    //Collection
    Collection c = new Vector();
    c.add("Matti");
    c.add("Maija");
    if ( c.contains("Matti") ) System.out.println("Matti sisltyy.");
    //Otetaan kokoelman sislt taulukkoon
    String nimet[] = (String[])c.toArray(new String[0]);

    //Iterator
    Iterator i = c.iterator();
    while ( i.hasNext() ) {
      if ( i.next().equals("Matti") ) i.remove();
    }

    //List
    List l = new Vector();
    l.add("Liisa");
    l.add(0,"Pekka");
    l.addAll(c); //c sislt nimen Maija
    //Luodaan nkym listan kahteen ensimmiseen alkioon ja
    //poistetaan nkymn kaikki oliot
    l.subList(0,2).clear();
    //Nyt listassa on jljell vain Maija

    l.add("Pekka");
    l.add("Liisa");

    //ListIterator
    ListIterator li = l.listIterator(l.size()); //iteraattori listan loppuun
    //Kydn lista takaperin lpi
    while(li.hasPrevious())
      System.out.println(li.previous());

    //SortedSet
    SortedSet s = new TreeSet(Henkilo.NIMEN_MUKAAN);
    Henkilo maija = new Henkilo("111167-5324","Maija");
    Henkilo pekka = new Henkilo("010147-2345","Pekka");
    s.add(new Henkilo("121256-1234","Matti"));
    s.add(maija);
    s.add(pekka);
    s.add(new Henkilo("221188-4322","Liisa"));
    System.out.println(s);                      //[Liisa, Maija, Matti, Pekka]
    System.out.println(s.headSet(maija));       //[Liisa]
    System.out.println(s.tailSet(maija));       //[Maija, Matti, Pekka]
    System.out.println(s.subSet(maija, pekka)); //[Maija, Matti]

    //Map
    Map m = new Hashtable();
    m.put(maija.getSotu(), maija);
    m.put(pekka.getSotu(), pekka);
    System.out.println(m); //{111167-5324=Maija, 010147-2345=Pekka}
    Henkilo h = (Henkilo)m.get("111167-5324");
    if ( h != null ) System.out.println(h.getNimi()); //Maija
    Set entrySet = m.entrySet();
    Iterator entryIterator = entrySet.iterator();
    while ( entryIterator.hasNext() ) {
      Map.Entry e = (Map.Entry)entryIterator.next();
      System.out.println( e.getKey() + "=" + e.getValue() );
    }

    //SortedMap
    SortedMap sm = new TreeMap(m);
    System.out.println(sm); //{010147-2345=Pekka, 111167-5324=Maija}

    //Algoritmit
    System.out.println("--Algoritmit--");
    System.out.println(l);  //[Maija, Pekka, Liisa]
    Collections.sort(l);
    System.out.println(l);  //[Liisa, Maija, Pekka]
    Collections.reverse(l);
    System.out.println(l);  //[Pekka, Maija, Liisa]
    Collections.shuffle(l);
    System.out.println(l);  //[?, ?, ?]



  }
}