import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class DBPalloApplet extends Applet implements Runnable {
  //Pallon nykyiset koordinaatit ja pallon kulkusuunta
  int x, y;
  int dirX = 3;
  int dirY = 2;
  int r = 10;
  boolean isRunning = true;

  Dimension offDimension; //Puskurissa olevan kuvan koko
  Image offImage;         //Varsinainen kuva
  Graphics offGraphics;   //Konteksti, jolla piiretn puskuriin


  /**Initialize the applet*/
  public void init() {
    //Luodaan sie, joka alkaa suorittaa run-metodia
    //Sikeist on oma lukunsa - nyt riitt tiet, ett
    //run-metodia aletaan suorittaa "omana ohjelmanaan"
    Thread t = new Thread(this);
    t.start();
  }

  public void destroy() {
    isRunning = false; //Tm lopettaa run-metodin silmukan
  }

  public void run() {
    while ( isRunning ) {
      //Tutkitaan pomppaako pallo seinst
      if ( x+r+dirX >= getSize().width || x+dirX < 0 ) dirX *= -1;
      if ( y+r+dirY >= getSize().height || y+dirY < 0 ) dirY *= -1;
      //Liikutetaan palloa
      x += dirX;
      y += dirY;
      //repaint(); //Pivitetn nytt
      repaint(x-5,y-5,15,15);
      try {
        Thread.sleep(100); //Odotetaan 100 millisekuntia
      } catch ( InterruptedException ie ) {
      }
    }
  }

  public void paint(Graphics g) {
    //Kutsutaan updatea. Nin pst helpommalla
    update(g);
  }

  public void update(Graphics g) {
    Dimension d = this.getSize(); //kysytn komponentin koko
    if ( (offGraphics == null)
         || (d.width != offDimension.width)
         || (d.height != offDimension.height) ) {
       //Puskuria ei alustettu tai komponentin koko on muuttunut
       offDimension = d; //Puskurin koko on komponentin koko
       //Luodaan komponentin kokoinen kuva
       offImage = createImage(d.width, d.height);
       //Ja otetaan silt konteksti, johon piirretn
       offGraphics = offImage.getGraphics();
    }

    //Nyt piirrelln puskuriin
    //Aluksi pit pyyhki tausta
    offGraphics.setColor(getBackground());
    offGraphics.fillRect(0, 0, d.width, d.height);
    //Vriksi edustavri ja piirretn kuten aikaisemminkin
    offGraphics.setColor(getForeground());
    offGraphics.fillRect(10,10,100,100);
    offGraphics.setColor(Color.gray);
    offGraphics.fillRect(200,200,100,100);
    offGraphics.setColor(Color.red);
    offGraphics.fillOval(x,y,10,10);

    //Ja lopuksi piirretn puskurin sislt kerralla nytlle
    g.drawImage(offImage, 0, 0, this);
  }

  /*Main method*/
  public static void main(String[] args) {
    PalloApplet applet = new PalloApplet();
    Frame frame;
    frame = new Frame();
    frame.setTitle("Applet Frame");
    frame.add(applet, BorderLayout.CENTER);
    applet.init();
    applet.start();
    frame.setSize(400,420);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);
  }
}
