/**
 * Title:
 * Description:
 * Copyright:
 * Company:
 * @author Mika Vesterholm
 * @version 1.0
 */

import java.awt.*;
import java.awt.event.*;

public class HelppoEurolaskuri extends Frame {
  ValuuttaPanel panelFIM = new ValuuttaPanel("FIM","Muunna euroiksi");
  ValuuttaPanel panelEUR = new ValuuttaPanel("EUR","Muunna markoiksi");

  public HelppoEurolaskuri() {
    //Listn tapahtumanksittelij ksittelemn ikkunan sulkeutuminen
    addWindowListener(new Lopeta());
    setTitle("Eurolaskuri"); //Asetataan ikkunan otsikko
    setSize(250,100);        //Ikkunan kooksi 250 * 100
    //Luodaan kaksi Valuuttapanelia
    //Luodaan asettelija ja asetetaan se hoitamaan tmn framen
    //komponenttien asettelu
    GridLayout gridLayout = new GridLayout(0,1);
    this.setLayout(gridLayout);
    //Listn luodut panelit framen sislle
    this.add(panelFIM);
    this.add(panelEUR);

    //Listn painikkeelle tapahtumankuuntelija
    panelFIM.painike.addActionListener(
      new HelppoEurolaskuri_FIMpainike_actionAdapter(this));
    //panelFIM.painike.addActionListener(new FIMPainike_Adapter());

    panelEUR.painike.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        EURpainike_actionPerformed(e);
      }
    });
  }


  //Tapahtumankuuntelija kutsuu tt metodia painiketta painettaessa
  void FIMpainike_actionPerformed(ActionEvent e) {
    double summa;
    try {
      summa = new Double(panelFIM.summa.getText()).doubleValue();
      panelEUR.summa.setText(""+(summa/5.94573));
    } catch (NumberFormatException nfe) {
      panelEUR.summa.setText("ERR");
    }
  }

/*
  class FIMPainike_Adapter implements ActionListener {
    //Tapahtuman lhde kutsuu tt metodia painiketta painettaessa
    public void actionPerformed(ActionEvent e) {
      double summa;
      try {
        summa = new Double(panelFIM.summa.getText()).doubleValue();
        panelEUR.summa.setText(""+(summa/5.94573));
      } catch (NumberFormatException nfe) {
        panelEUR.summa.setText("ERR");
      }
    }
  }
*/

  //Tapahtumankuuntelija kutsuu tt metodia painiketta painettaessa
  void EURpainike_actionPerformed(ActionEvent e) {
    double summa;
    try {
      summa = new Double(panelEUR.summa.getText()).doubleValue();
      panelFIM.summa.setText(""+(summa*5.94573));
    } catch (NumberFormatException nfe) {
      panelFIM.summa.setText("ERR");
    }
  }


  /** Ohjelman kynnistv metodi. */
  public static void main(String[] args) {
    HelppoEurolaskuri laskuri = new HelppoEurolaskuri();
    laskuri.show(); //Ikkuna nkyviin
  }
}

class ValuuttaPanel extends Panel {
   //Attribuutteina on muutama komponentti, jotka luodaan mrittelyn yhteydess
   Label selite = new Label();
   TextField summa = new TextField();
   Button painike = new Button();

   public ValuuttaPanel(String valuutta, String painiketeksti) {
     selite.setText(valuutta);        //Asetaan selitteen teksti
     painike.setLabel(painiketeksti); //ja painikkeen teksti
     //Listn komponentit paneelille. Paneelin olutusasettelija
     //on FlowLayout, joten lismisess ei tarvita erityisi parametrej
     add(selite);
     add(summa);
     add(painike);
   }
}

class HelppoEurolaskuri_FIMpainike_actionAdapter implements ActionListener {
  //viite HelppoEurolaskuriin, jotta voidaan kutsua sen metodeja
  HelppoEurolaskuri adaptee;

  //Konstrutori, joka asettaa viiteen paikoilleen.
  HelppoEurolaskuri_FIMpainike_actionAdapter(HelppoEurolaskuri adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    //Kutsutaan HelppoEurolaskurin metodia
    adaptee.FIMpainike_actionPerformed(e);
  }
}
