/**
 * Title:
 * Description:
 * Copyright:
 * Company:
 * @author Mika Vesterholm
 * @version 1.0
 */

import java.awt.*;
import java.awt.event.*;

public class KomponentitApp extends Frame {
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  //--Nimi, tekstikentt ja tekstialue--
  Panel panel1 = new Panel();
  Label label1 = new Label();
  TextField textField1 = new TextField();
  TextArea textArea1 = new TextArea();

  //--Lista ja valintalista--
  Panel panel2 = new Panel();
  List list1 = new List();
  Choice choice1 = new Choice();
  Panel panel3 = new Panel();

  //--Valintaruudut--
  Checkbox checkbox1 = new Checkbox();
  Checkbox checkbox2 = new Checkbox();
  Checkbox checkbox3 = new Checkbox();
  CheckboxGroup checkboxGroup1 = new CheckboxGroup();
  Panel panel4 = new Panel();

  //--Vierityspalkki--
  Label label2 = new Label();
  Scrollbar scrollbar1 = new Scrollbar();

  //--Valikot--
  MenuBar menuBar1 = new MenuBar();
  Menu menu1 = new Menu();
  Menu menu2 = new Menu();
  Menu menu3 = new Menu();
  MenuItem menuItem1 = new MenuItem();
  MenuItem menuItem2 = new MenuItem();
  MenuItem menuItem3 = new MenuItem();
  MenuItem menuItem4 = new MenuItem("Valikon kohta");
  CheckboxMenuItem checkboxMenuItem1 = new CheckboxMenuItem();
  PopupMenu popupMenu1 = new PopupMenu();

  public KomponentitApp() {
    this.setBackground(SystemColor.control);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.setLayout(gridBagLayout1);

    //--Nimi, tekstikentt ja tekstialue--
    label1.setText("Nimi");
    textField1.setText("Tekstikentt");
    textField1.addTextListener(new KomponentitApp_textField1_textAdapter(this));
    textField1.addActionListener(new KomponentitApp_textField1_actionAdapter(this));
    //Tekstialueen korkeudeksi 3 rivi ja noin 20 merkki leveytt.
    textArea1.setColumns(20);
    textArea1.setRows(3);
    textArea1.setText("Tekstialue");

    //--Lista ja valintalista--
    list1.addActionListener(new KomponentitApp_list1_actionAdapter(this));
    list1.add("Vaihtoehto 1");
    list1.add("Lopeta");
    list1.add("Vaihtoehto 2",1);

    choice1.addItemListener(new KomponentitApp_choice1_itemAdapter(this));
    choice1.add("Yksi");
    choice1.add("Monta");

    checkbox1.setLabel("Kytss");
    checkbox1.setState(true);
    checkbox1.addItemListener(new KomponentitApp_checkbox1_itemAdapter(this));
    checkbox2.setLabel("Kyll");
    checkbox2.setCheckboxGroup(checkboxGroup1);
    checkbox3.setLabel("Ei");
    checkbox3.setCheckboxGroup(checkboxGroup1);
    //Asetetaan ryhmn yksi vaihtoehto valituksi
    //ryhmn valittu kohta pit asettaa nin tai
    //ryhm toimii aluksi kummallisesti
    checkboxGroup1.setSelectedCheckbox(checkbox2);

    //--vierityspalkki--
    scrollbar1.setMaximum(50);
    scrollbar1.setMinimum(10);
    scrollbar1.setOrientation(Scrollbar.HORIZONTAL);
    scrollbar1.setBlockIncrement(5);
    scrollbar1.setVisibleAmount(1);
    scrollbar1.addAdjustmentListener(new KomponentitApp_scrollbar1_adjustmentAdapter(this));
    label2.setText("10");

    //--valikot--
    //asetetaan valikkojen ominaisuuksia
    menu1.setLabel("Menu1");
    menu2.setLabel("Menu2");
    menuItem1.setLabel("MenuItem");
    checkboxMenuItem1.setLabel("CheckboxMenuItem");
    menuItem2.setLabel("Lopeta");
    menuItem2.setShortcut(new MenuShortcut(KeyEvent.VK_X));
    menuItem2.addActionListener(new KomponentitApp_menuItem2_actionAdapter(this));
    menu3.setLabel("Help");
    menu3.setEnabled(false);
    menuItem3.setLabel("Apua");
    //luodaan valikkohierarkia
    this.setMenuBar(menuBar1);
    menuBar1.add(menu1);
    menuBar1.setHelpMenu(menu3);
    menu1.add(checkboxMenuItem1);
    menu1.add(menu2);
    menu1.addSeparator();
    menu1.add(menuItem2);
    menu2.add(menuItem1);
    menu3.add(menuItem3);
    //pikavalikko
    popupMenu1.add(menuItem4);
    this.add(popupMenu1);
    this.addMouseListener(new KomponentitApp_this_mouseAdapter(this));

    this.add(panel1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    panel1.add(label1, null);
    panel1.add(textField1, null);
    panel1.add(textArea1, null);
    this.add(panel2, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    panel2.add(list1, null);
    panel2.add(choice1, null);
    this.add(panel3, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    panel3.add(checkbox1, null);
    panel3.add(checkbox2, null);
    panel3.add(checkbox3, null);
    this.add(panel4, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    panel4.add(scrollbar1, null);
    panel4.add(label2, null);
  }

  public static void main(String[] args) {
    KomponentitApp app = new KomponentitApp();
    //Listn tapahtumanksittelij ksittelemn ikkunan sulkeutuminen
    app.addWindowListener(new Lopeta());
    app.pack();
    app.show();           //Nytetn ikkuna
  }

  void textField1_actionPerformed(ActionEvent e) {
    //Jos kyttj kirjoittaa tekstikenttn lopeta ja painaa enteri,
    //ohjelman suoritus loppuu
    if ( textField1.getText().equalsIgnoreCase("lopeta") )
      System.exit(0);
  }

  void textField1_textValueChanged(TextEvent e) {
    //onko kyttj kirjoittanut tekstikenttn valitse
    if ( textField1.getText().equalsIgnoreCase("valitse") ) {
      textArea1.select(2, 5); //valitaan tekstialueesta teksti
      textField1.setCaretPosition(0); //kursori tekstikentn alkuun
    }
  }

  void list1_actionPerformed(ActionEvent e) {
    //Jos listasta tuplaklikataan vaihtoehtoa lopeta
    //Vertailu list.getSelectedItem().equals("Lopeta") ei toimi,
    //sill getSelectedItem palauttaa null, jos listassa ei ole
    //valituna yht vaihtoehtoa
    if ( "Lopeta".equals( list1.getSelectedItem() )  ) {
      System.exit(0);
    }
  }

  void choice1_itemStateChanged(ItemEvent e) {
    //Muutetaan listan tilaa valinnan mukaan
    if ( e.getStateChange() == ItemEvent.SELECTED &&
         choice1.getSelectedIndex() == 0 ) {
      list1.setMultipleMode(false);
    } else {
      list1.setMultipleMode(true);
    }
  }

  void checkbox1_itemStateChanged(ItemEvent e) {
    //Muita valintaruutuja voi kytt vain, jos ensimminen on valittuna
    checkbox2.setEnabled(checkbox1.getState());
    checkbox3.setEnabled(checkbox1.getState());
  }

  void scrollbar1_adjustmentValueChanged(AdjustmentEvent e) {
    //Nimin tekstiksi vierityspalkin kuvaama arvo
    label2.setText(""+scrollbar1.getValue());
  }

  void menuItem2_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  void this_mousePressed(MouseEvent e) {
    popupMenu1.show(this, e.getX(), e.getY());
  }

}

class KomponentitApp_textField1_actionAdapter implements java.awt.event.ActionListener {
  KomponentitApp adaptee;

  KomponentitApp_textField1_actionAdapter(KomponentitApp adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.textField1_actionPerformed(e);
  }
}

class KomponentitApp_textField1_textAdapter implements java.awt.event.TextListener {
  KomponentitApp adaptee;

  KomponentitApp_textField1_textAdapter(KomponentitApp adaptee) {
    this.adaptee = adaptee;
  }
  public void textValueChanged(TextEvent e) {
    adaptee.textField1_textValueChanged(e);
  }
}

class KomponentitApp_list1_actionAdapter implements java.awt.event.ActionListener {
  KomponentitApp adaptee;

  KomponentitApp_list1_actionAdapter(KomponentitApp adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.list1_actionPerformed(e);
  }
}

class KomponentitApp_choice1_itemAdapter implements java.awt.event.ItemListener {
  KomponentitApp adaptee;

  KomponentitApp_choice1_itemAdapter(KomponentitApp adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.choice1_itemStateChanged(e);
  }
}

class KomponentitApp_checkbox1_itemAdapter implements java.awt.event.ItemListener {
  KomponentitApp adaptee;

  KomponentitApp_checkbox1_itemAdapter(KomponentitApp adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkbox1_itemStateChanged(e);
  }
}

class KomponentitApp_scrollbar1_adjustmentAdapter implements java.awt.event.AdjustmentListener {
  KomponentitApp adaptee;

  KomponentitApp_scrollbar1_adjustmentAdapter(KomponentitApp adaptee) {
    this.adaptee = adaptee;
  }
  public void adjustmentValueChanged(AdjustmentEvent e) {
    adaptee.scrollbar1_adjustmentValueChanged(e);
  }
}

class KomponentitApp_menuItem2_actionAdapter implements java.awt.event.ActionListener {
  KomponentitApp adaptee;

  KomponentitApp_menuItem2_actionAdapter(KomponentitApp adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.menuItem2_actionPerformed(e);
  }
}

class KomponentitApp_this_mouseAdapter extends java.awt.event.MouseAdapter {
  KomponentitApp adaptee;

  KomponentitApp_this_mouseAdapter(KomponentitApp adaptee) {
    this.adaptee = adaptee;
  }
  public void mousePressed(MouseEvent e) {
    adaptee.this_mousePressed(e);
  }
}
