import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;

public class Eurolaskuri extends Applet {
  //static Locale locale = new Locale("fi","FI");
  static Locale locale = new Locale("de","DE");

  static ResourceBundle res = ResourceBundle.getBundle("EurolaskuriRes", locale);
  static ResourceBundle cur = ResourceBundle.getBundle("EurolaskuriCur", locale);

  boolean isStandalone = false;
  Panel panel1 = new Panel();
  Label labelFIM = new Label();
  TextField textFieldFIM = new TextField();
  Button buttonFIM = new Button();
  Panel panel2 = new Panel();
  Label labelEUR = new Label();
  TextField textFieldEUR = new TextField();
  Button buttonEUR = new Button();
  BorderLayout borderLayout1 = new BorderLayout();
  FlowLayout flowLayout1 = new FlowLayout();
  FlowLayout flowLayout2 = new FlowLayout();
  /**Get a parameter value*/
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  /**Construct the applet*/
  public Eurolaskuri() {
  }
  /**Initialize the applet*/
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**Component initialization*/
  private void jbInit() throws Exception {
    labelFIM.setText(res.getString("labelFIM_Text"));
    textFieldFIM.setColumns(5);
    textFieldFIM.setText("1.0");
    buttonFIM.setLabel(res.getString("buttonFIM_Label"));
    buttonFIM.addActionListener(new Eurolaskuri_buttonFIM_actionAdapter(this));
    labelEUR.setText(res.getString("labelEUR_Text"));
    textFieldEUR.setColumns(5);
    buttonEUR.setLabel(res.getString("buttonEUR_Label"));
    buttonEUR.addActionListener(new Eurolaskuri_buttonEUR_actionAdapter(this));
    this.setLayout(borderLayout1);
    panel1.setLayout(flowLayout1);
    flowLayout1.setAlignment(FlowLayout.LEFT);
    panel2.setLayout(flowLayout2);
    flowLayout2.setAlignment(FlowLayout.LEFT);
    this.add(panel1, BorderLayout.NORTH);
    panel1.add(labelFIM, null);
    panel1.add(textFieldFIM, null);
    panel1.add(buttonFIM, null);
    this.add(panel2, BorderLayout.CENTER);
    panel2.add(labelEUR, null);
    panel2.add(textFieldEUR, null);
    panel2.add(buttonEUR, null);
  }
  /**Get Applet information*/
  public String getAppletInfo() {
    return "Applet Information";
  }
  /**Get parameter info*/
  public String[][] getParameterInfo() {
    return null;
  }
  /**Main method*/
  public static void main(String[] args) {
    Eurolaskuri applet = new Eurolaskuri();
    applet.isStandalone = true;
    Frame frame;
    frame = new Frame() {
      protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
          System.exit(0);
        }
      }
      public synchronized void setTitle(String title) {
        super.setTitle(title);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      }
    };
    frame.setTitle("Applet Frame");
    frame.add(applet, BorderLayout.CENTER);
    applet.init();
    applet.start();
    frame.setSize(400,320);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);
  }

  void buttonFIM_actionPerformed(ActionEvent e) {
    muunnaEuroiksi();
  }

  void buttonEUR_actionPerformed(ActionEvent e) {
    muunnaMarkoiksi();
  }

  protected void muunnaEuroiksi() {
    double summa;
    try {
      double kerroin = ((Double)cur.getObject("kerroin")).doubleValue();
      summa = new Double(textFieldFIM.getText()).doubleValue();
      textFieldEUR.setText(""+(summa/kerroin));
    } catch (NumberFormatException nfe) {
      textFieldEUR.setText(res.getString("textFieldEUR_Text"));
    }
  }
  protected void muunnaMarkoiksi() {
    double summa;
    try {
      double kerroin = ((Double)cur.getObject("kerroin")).doubleValue();
      summa = new Double(textFieldEUR.getText()).doubleValue();
      textFieldFIM.setText(""+(summa*kerroin));
    } catch (NumberFormatException nfe) {
      textFieldFIM.setText(res.getString("textFieldEUR_Text"));
    }
  }


}

class Eurolaskuri_buttonFIM_actionAdapter implements java.awt.event.ActionListener {
  Eurolaskuri adaptee;

  Eurolaskuri_buttonFIM_actionAdapter(Eurolaskuri adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonFIM_actionPerformed(e);
  }
}

class Eurolaskuri_buttonEUR_actionAdapter implements java.awt.event.ActionListener {
  Eurolaskuri adaptee;

  Eurolaskuri_buttonEUR_actionAdapter(Eurolaskuri adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonEUR_actionPerformed(e);
  }
}
