

/**
 * Title:
 * Description:
 * Copyright:
 * Company:
 * @author Mika Vesterholm
 * @version 1.0
 */
import java.io.*;

public class LukuKirjoitus {
  public static void main(String[] args) {
    Writer writer = null;
    BufferedWriter bwriter = null;
    try {
      //luodaan merkkivirta tiedostoon kirjoittamista varten
      writer = new FileWriter("testitiedosto.txt");
      //luodaan puskuroitu merkkivirta
      //puskuri lukee tiedot edell luodusta virrasta
      bwriter = new BufferedWriter(writer);
      //kirjoiteaan tiedostoon teksti
      bwriter.write("Teksti tiedostoon");
      bwriter.newLine();
      bwriter.write("Toinen rivi");
      //pakotetaan virta kirjoittamaan puskuroitu data tiedostoon
      bwriter.flush();
    } catch ( IOException ioe ) {
      ioe.printStackTrace();
    } finally {
      //Pidetn huolta, ett virta suljetaan aina. Puskuroidun virran
      //sulkeminen sulkee mys virran, jota puskuri kytt
      try {
        if (bwriter != null) bwriter.close();
      } catch(IOException ioe) {
        ioe.printStackTrace();
      }
    }


    OutputStream out = null;
    try {
      //luodaan binrivirta tiedostoon kirjoittamista varten
      out = new FileOutputStream("utf-8.txt");
      //luodaan merkkivirta, joka kirjoittaa binrivirtaan kytten
      //annettua merkist. Kaikki virtuaalikoneet tukevat ainakin
      //merkistj UTF-8, ISO-8859-1 ja US-ASCII
      writer = new OutputStreamWriter(out,"UTF-8");
      //puskuroidaan virta
      bwriter = new BufferedWriter(writer);
      //kirjoiteaan tiedostoon teksti
      bwriter.write("Teksti tiedostoon");
      bwriter.newLine();
      bwriter.write("Toinen rivi");
    } catch ( IOException ioe ) {
      ioe.printStackTrace();
    } finally {
      //Pidetn huolta, ett virta suljetaan aina. Puskuroidun virran
      //sulkeminen sulkee mys virran, jota puskuri kytt
      try {
        if (bwriter != null) bwriter.close();
      } catch(IOException ioe) {
        ioe.printStackTrace();
      }
    }


    InputStream in = null;
    Reader reader = null;
    BufferedReader breader = null;
    try {
      //luodaan binrivirta tiedostosta lukemista varten
      in = new FileInputStream("utf-8.txt");
      //luodaan merkkivirta, joka lukee merkit binrivirrasta kytten
      //annettua merkist.
      reader = new InputStreamReader(in, "UTF-8");
      //puskuroidaan virta
      breader = new BufferedReader(reader);
      String rivi = null;
      //BuuferedReader-luokalla on metodi rivien lukemiseen
      //metodi palauttaa null, jos on psty tiedoston loppuun
      while( (rivi=breader.readLine()) != null ) {
        System.out.println(rivi);
      }
    } catch ( IOException ioe ) {
      ioe.printStackTrace();
    } finally {
      //suljetaan virta
      try {
        if (breader != null) breader.close();
      } catch(IOException ioe) {
        ioe.printStackTrace();
      }
    }


try {
  //luodaan binrivirta tiedostoon kirjoittamista varten
  FileOutputStream fileOut = new FileOutputStream("henkilot.dat");
  //luodaan oliovirta, joka kirjoittaa edell luotuun binrivirtaan
  ObjectOutputStream objOut = new ObjectOutputStream(fileOut);
  Henkilo matti = new Henkilo("123456-7890","Matti"); //luodaan olio
  Henkilo maija = new Henkilo("123456-7890","Matti"); //luodaan olio
  //Kirjoitetaan oliot virtaan
  objOut.writeObject(matti);
  objOut.writeObject(maija);
  objOut.close(); //suljetaan virta, sulkee samalla tiedoston

  //luodaan binrivirta tiedostosta lukemista varten
  FileInputStream fileIn = new FileInputStream("henkilot.dat");
  //oliovirta, joka lukee oliot edell luodusta binrivirrasta
  ObjectInputStream objIn = new ObjectInputStream(fileIn);
  //Luetaan henkilt virrasta - metodit aiheuttavat poikkeuksen, jos
  //luettavan olion luokan mrittely ei lydy
  try {
    Henkilo h1 = (Henkilo)objIn.readObject();
    Henkilo h2 = (Henkilo)objIn.readObject();
  } catch (ClassNotFoundException cnfe) {
    cnfe.printStackTrace();
  }
  objIn.close(); //virta kiinni
} catch ( IOException ioe ) {
  System.out.println(ioe.getMessage());
}

  }
}