import java.util.*;
import java.net.*;

/**
 * Chat server main class. Accepts clients and creates ClientHandler
 * to handle the client.
 * @see ClientHandler
 * @author Mika Vesterholm
 * @version 1.0
 */
public class ChatServer {

  /**
   * The main method. Creates ServerSocket and accepts clients.
   */
  public static void main(String[] args) {
    ServerSocket ss = null;
    try {
      ss = new ServerSocket(8989);
    } catch (Exception ex) {
      System.out.println("Server failed to start.");
      System.out.println(ex.getMessage());
      System.exit(-1);
    }

    Vector clients = new Vector();
    while(true) {
      try {
        Socket s = ss.accept();
        new ClientHandler(s, clients).start();
      } catch (Exception ex) {
        ex.printStackTrace();
      }
    }
  }
}