import java.awt.*;
import java.awt.event.*;

/**
 * Title:
 * Description:
 * Copyright:
 * Company:
 * @author Mika Vesterholm
 * @version 1.0
 */

public class LoginDialog extends Dialog {
  String userName = null;

  Panel panel1 = new Panel();
  Label label1 = new Label();
  FlowLayout flowLayout1 = new FlowLayout();
  TextField textFieldUserName = new TextField();
  Button buttonLogin = new Button();

  public LoginDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public LoginDialog(Frame frame) {
    this(frame, "", false);
  }

  public LoginDialog(Frame frame, boolean modal) {
    this(frame, "", modal);
  }

  public LoginDialog(Frame frame, String title) {
    this(frame, title, false);
  }
  void jbInit() throws Exception {
    label1.setText("User name:");
    panel1.setLayout(flowLayout1);
    textFieldUserName.setColumns(10);
    buttonLogin.setLabel("Login");
    buttonLogin.addActionListener(new LoginDialog_buttonLogin_actionAdapter(this));
    flowLayout1.setAlignment(FlowLayout.LEFT);
    panel1.add(label1, null);
    panel1.add(textFieldUserName, null);
    panel1.add(buttonLogin, null);
  }
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  protected void cancel() {
    userName = null;
    dispose();
  }

  protected void login() {
    userName = textFieldUserName.getText();
    dispose();
  }

  void buttonLogin_actionPerformed(ActionEvent e) {
    login();
  }

  public String getUserName() { return userName; }
}

class LoginDialog_buttonLogin_actionAdapter implements java.awt.event.ActionListener {
  LoginDialog adaptee;

  LoginDialog_buttonLogin_actionAdapter(LoginDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonLogin_actionPerformed(e);
  }
}
