import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.*;

public class VieraskirjaServlet extends HttpServlet {
  private Connection con;
  private PreparedStatement insertStmt;

  public void init() throws ServletException {
    try {
      connect();
    } catch(Exception e) {
      //Virheen sattuessa kirjataan tapahtuma lokiin ja
      //heitetn poikkeus
      e.printStackTrace();
      log("VieraskirjaServlet ei kynnistynyt.", e);
      throw new UnavailableException("Kantaan ei saatu yhteytt.");
    }
  }

  private synchronized void connect() throws Exception {
    //tutkitaan onko yhteys jo auki
    if (con != null && !con.isClosed()) return;
    //Luodaan tietokantayhteys
    Class.forName("interbase.interclient.Driver");
    String url="jdbc:interbase://localhost/c:/databases/vieraat.gdb";
    con = DriverManager.getConnection(url,"sysdba","sala");
    insertStmt =
      con.prepareStatement("INSERT INTO VIERAAT VALUES(?, ?)");
  }

  /**Process the HTTP Get request*/
  public void doGet(HttpServletRequest request,
                    HttpServletResponse response)
   throws ServletException, IOException {
    Statement stmt = null;
    ResultSet rs = null;
    try {
      if (con.isClosed()) connect();
      stmt = con.createStatement();
      rs = stmt.executeQuery("SELECT * FROM VIERAAT");
    } catch(Exception e) {
      log("Virhe haettaessa tietoja.", e);
      response.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR);
      return;
    }
    response.setContentType("text/html");
    PrintWriter out = response.getWriter();
    out.println("<html>");
    out.println("<head><title>VieraskirjaServlet</title></head>");

    out.println("<form action=\"VieraskirjaServlet\" method=POST>");
    out.println("Nimi: <input type=text size=20 name=nimi><br>");
    out.println("Email: <input type=text size=20 name=email><br>");
    out.println("<input type=submit></form>");

    out.println("<body><table><tr><th>Nimi<th>email");

    try {
      while(rs.next()) {
        out.print("<tr><td>"+rs.getString("nimi"));
        out.println("<td>"+rs.getString("email"));
      }
    } catch(SQLException se) {
       out.println("Virhe!");
    }
    out.println("</table></body></html>");
  }
  /**Process the HTTP Post request*/
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    String nimi = request.getParameter("nimi");
    String email = request.getParameter("email");

    response.setContentType("text/html");
    PrintWriter out = response.getWriter();
    out.println("<html>");
    out.println("<head><title>VieraskirjaServlet</title></head>");
    out.println("<body>");

    if (nimi == null || email == null)
      out.println("Molemmat kentt on tytettv!");
    else {
      try {
        if (con.isClosed()) connect();
        //Varmistetaan, ett vain yksi asiakkaista tekee lisyst
        //kerrallaan
        synchronized(this) {
          insertStmt.setString(1, nimi);
          insertStmt.setString(2, email);
          insertStmt.executeUpdate();
        }
        out.println("Lisys onnistui<br>");
      } catch(Exception e) {
        out.println("Lisys eponnistui!<br>");
      }
    }
    out.println("<a href=\"VieraskirjaServlet\">Vieraskirjaan</a>");
    out.println("</body></html>");
  }

  public void destroy() {
    try {
      //suljetaan tietokantayhteys
      con.close();
    } catch (SQLException se) {
    }
    con = null;
  }
}
