﻿<?xml version="1.0"?> 
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:fo="http://www.w3.org/1999/XSL/Format" version="1.0">
  <xsl:template match="/">

  <fo:root xmlns:fo="http://www.w3.org/1999/XSL/Format">

  <!-- sivun asetukset -->
  <fo:layout-master-set>
    <fo:simple-page-master master-name="first" 
                           page-height="29.7cm" 
                           page-width="21cm" 
                           margin-top="1cm" 
                           margin-bottom="2cm" 
                           margin-left="2.5cm" 
                           margin-right="2.5cm">
      <fo:region-before extent="3cm"/>
      <fo:region-body margin-top="3cm"/>
      <fo:region-after extent="1.5cm"/>
    </fo:simple-page-master>
  </fo:layout-master-set>

  <!-- sivujen sisältö -->
  <fo:page-sequence master-name="first">

  <!-- ylätunniste, jossa sivunumero -->
  <fo:static-content flow-name="xsl-region-before">
    <fo:block text-align="end" font-size="10pt" font-family="serif" line-height="14pt">
      Kallen Kaupan hinnasto - sivu <fo:page-number/>
    </fo:block>
  </fo:static-content>

  <fo:flow flow-name="xsl-region-body">

      <fo:block font-size="10pt" font-family="sans-serif" 
                line-height="10pt" space-after.optimum="3pt" 
                font-weight="bold" start-indent="15pt">
          Tuotteet
      </fo:block>

      <!-- Taulukon alku -->
      <fo:table>
        <fo:table-column column-width="10cm"/>
        <fo:table-column column-width="2cm"/>
        <fo:table-column column-width="2cm"/>
        <fo:table-body font-size="10pt" font-family="sans-serif">

        <fo:table-row line-height="12pt">

        <fo:table-cell>
          <fo:block text-align="start">Tuote</fo:block>
        </fo:table-cell>

        <fo:table-cell>
        <fo:block text-align="start">Hinta</fo:block>
        </fo:table-cell>

        <fo:table-cell>
        <fo:block text-align="start">Valuutta</fo:block>
        </fo:table-cell>

        </fo:table-row>

        <xsl:apply-templates/>    

        </fo:table-body>
      </fo:table>
    </fo:flow>
  </fo:page-sequence>
  </fo:root>

  </xsl:template>    


  <xsl:template match="tuotteet">
    <xsl:for-each select="tuote">
      <xsl:sort select="nimi"/>

        <fo:table-row line-height="12pt">

        <fo:table-cell>
          <fo:block text-align="start"><xsl:value-of select="nimi"/></fo:block>
        </fo:table-cell>

        <fo:table-cell>
          <fo:block text-align="start"><xsl:value-of select="hinta"/></fo:block>
        </fo:table-cell>

        <fo:table-cell>
          <fo:block text-align="start"><xsl:value-of select="hinta/@valuutta"/></fo:block>
        </fo:table-cell>

        </fo:table-row>

    </xsl:for-each>
  </xsl:template>

</xsl:stylesheet>
