/**
 * Title:
 * Description:
 * Copyright:
 * Company:
 * @author Mika Vesterholm
 * @version 1.0
 */
import org.apache.fop.apps.Driver;
import org.apache.fop.apps.Version;

import org.apache.xerces.parsers.SAXParser;

import org.xml.sax.XMLReader;
import org.xml.sax.InputSource;

import org.apache.xalan.xslt.XSLTProcessor;
import org.apache.xalan.xslt.XSLTInputSource;
import org.apache.xalan.xslt.XSLTResultTarget;
import org.apache.xalan.xslt.XSLTProcessorFactory;

import java.io.*;

public class XMLToPDF {
  public static void main(String[] args) {

try {
  //luodaan muunnoksen tekij
  XSLTProcessor processor = XSLTProcessorFactory.getProcessor();

  //luodaan muunnoksessa tarvittavat tietolhteet
  XSLTInputSource xmlSource =  new XSLTInputSource("tuotteet.xml");
  XSLTInputSource xslSheet  =  new XSLTInputSource("TuotteetFO.xsl");
  XSLTResultTarget xmlResult = new XSLTResultTarget("tmp.fo");

  //suoritetaan muunnos
  processor.process(xmlSource, xslSheet, xmlResult);

  //Muunnetaan saatu tiedosto PDF:ksi
  XMLReader p = new SAXParser();
  p.setFeature("http://xml.org/sax/features/namespace-prefixes",true);

  Driver d = new Driver();
  d.setRenderer("org.apache.fop.render.pdf.PDFRenderer", Version.getVersion());
  d.addElementMapping("org.apache.fop.fo.StandardElementMapping");
  d.addElementMapping("org.apache.fop.svg.SVGElementMapping");
  d.addPropertyList("org.apache.fop.fo.StandardPropertyListMapping");
  d.addPropertyList("org.apache.fop.svg.SVGPropertyListMapping");
  d.setWriter(new PrintWriter(new FileWriter("tuotteet.pdf")));
  d.buildFOTree(p, new InputSource("tmp.fo"));
  d.format();
  d.render();
} catch ( Exception e ) {
  e.printStackTrace();
}

 }
}