// Tss mritelln muutamia omia poikkeustyyppej.
// Poikkeusluokissa on yleens konstruktorit mutta niiss ei ole tietoja 
// tai muita metodeita. Niss konstruktoreissa kutsutaan vain yliluokan 
// konstruktoria.
class MyException extends Exception {
  public MyException() { super(); }
  public MyException(String s) { super(s); }
}
class MyOtherException extends Exception {
  public MyOtherException() { super(); }
  public MyOtherException(String s) { super(s); }
}
class MySubException extends MyException {
  public MySubException() { super(); }
  public MySubException(String s) { super(s); }
}
public class throwtest {
  // Tm on main()-metodi. Huomaa, ett siin otetaan kahdella
  // erillisell catch-lauseella kiinni kaksi Javan standardipoikkeusta.
  public static void main(String argv[]) {
    int i;
    
    // Muunnetaan argumentti ensin kokonaisluvuksi.
    // Varmistetaan, ett argumentti on annettu ja ett sen voi muuntaa.
    try {  i = Integer.parseInt(argv[0]);  }
    catch (ArrayIndexOutOfBoundsException e) { // argv on tyhj
      System.out.println("Must specify an argument");
      return;
    }
    catch (NumberFormatException e) { // argv[0] ei ole kokonaisluku
      System.out.println("Must specify an integer argument.");
      return;
    }
    
    // Annetaan argumentti metodille a().
    a(i);
  }
  
  // Tss metodissa kutsutaan metodia b(), jonka mrittelyss on 
  // kerrottu, ett se voi aiheuttaa yhdenlaisen poikkeuksen. Varaudutaan 
  // ksittelemn poikkeus.
  public static void a(int i) {
    try {
      b(i);
    }
    catch (MyException e) {                               // Kohta 1
      // Tss ksitelln MyException ja sen aliluokka MySubException.
      if (e instanceof MySubException)
        System.out.print("MySubException: ");
      else
        System.out.print("MyException: ");
      System.out.println(e.getMessage());
      System.out.println("Handled at point 1");
    }
  }
  // Tss metodissa kutsutaan metodia c() ja ksitelln toiset metodin
  // mahdollisesti aiheuttamista poikkeuksista. Toisen tyyppisi 
  // poikkeuksia ei ksitell joten ne siirtyvt kutsujan vastuulle ja ne 
  // on esitelty tmn metodin throws-mreess. Tss metodissa on mys 
  // finally-osa, jossa ptetn try-lohkossa tehty ty. Huomaa, ett 
  // finally-osa suoritetaan paikallisen catch-osan jlkeen mutta ennen 
  // ulompaa catch-osaa tai sellaista catch-osaa, joka on tt metodia 
  // kutsuneessa metodissa.
public static void b(int i) throws MyException {
    int result;
    try {
      System.out.print("i = " + i);
      result = c(i);
      System.out.print(" c(i) = " + result);
    }
    catch (MyOtherException e) {                                 // Kohta 2
      // Ksitelln MyOtherException-poikkeukset:
      System.out.println("MyOtherException: " + e.getMessage());
      System.out.println("Handled at point 2");
    }
    finally {
      // Lopetetaan yll tehty tulostus rivinvaihdolla
      System.out.print("\n");
    }
  }
  
  // Tss metodissa lasketaan arvo tai aiheutetaan poikkeus.
  // throws-mreess on lueteltu vain kaksi poikkeustyyppi, koska
  // yksi poikkeuksista on toisen poikkeusluokan aliluokka.
  public static int c(int i) throws MyException, MyOtherException {
    switch (i) {
    case 0:      // Suoritusta jatketaan kohdasta 1
      throw new MyException("input too low");
    case 1:      // Suoritusta jatketaan kohdasta 1
      throw new MySubException("input still too low");
    case 99:     // Suoritusta jatketaan kohdasta 2
      throw new MyOtherException("input too high");
    default:
      return i*i;
    }
  }
}