package shapes;             // Mritelln luokan paketti.
public class Circle {       // Huomaa, ett luokka on yh julkinen!
    protected double x, y;  // Positio on ktketty, mutta se nkyy 
                            // aliluokille.
    protected double r;     // Sde on ktketty, mutta se nkyy aliluokille.
    // Suurin mahdollinen sde (vakio).
    private static final double MAXR = 100.0;
    private boolean check_radius(double r) { return (r <= MAXR); }
    // Julkiset konstruktorit
    public Circle(double x, double y, double r) {
        this.x = x; this.y = y; 
        if (check_radius(r)) this.r = r;
        else this.r = MAXR;
    }
    public Circle(double r) { this(0.0, 0.0, r); }
    public Circle() { this(0.0, 0.0, 1.0); }
    // Julkiset kenttien kyttmetodit
    public void moveto(double x, double y) { this.x = x; this.y = y;}
    public void move(double dx, double dy) { x += dx;  y += dy; }
    public void setRadius(double r) { this.r = (check_radius(r))?r:MAXR; }
    // Nm pienet metodit mritelln final-tyyppisiksi, jotta tulkin
    // ei tarvitse mietti suoritettavaa metodia ajonaikaisesti ja jotta
    // kntj voisi tehd niist avoimia.
    public final double getX() { return x; };
    public final double getY() { return y; };
    public final double getRadius() { return r; };
} 