import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;
/** 
 * Java-appletti, joka simuloi linkkikuvaa. Appletti soittaa nen 
 * aina kun kyttj painaa jotakin linkeist.
 */
public class Soundmap extends Applet {
  protected Image image;      // Nytettv kuva.
  protected Vector rects;     // Kuvassa olevat suorakaiteet.
  protected AudioClip sound;  // ni, joka soitetaan
  /** Alustetaan appletti */
  public void init() {
    // Kysytn kuvaun nimi, joka annetaan suhteessa koti-URL-osoitteeseen. 
    // Ladataan kuva. Huomaa, miten tll yhdell rivill kutsutaan kolmea
    // applet-luokan metodia.
    image = this.getImage(this.getDocumentBase(),   
                          this.getParameter("image"));
    // Kydn lpi ja jsennelln joukko suorakaidemrittelyj ja URL-
    // osoitteita joita ne vastaavat. Apurutiini getRectangleParameter() on 
    // mritelty alla.
    rects = new Vector();
    ImagemapRectangle r;
    for(int i = 0; (r = getRectangleParameter("rect" + i)) != null; i++)
      rects.addElement(r);
    // Selvitetn ni, joka pit soittaa, kun kyttj painaa aluetta.
    sound = this.getAudioClip(this.getDocumentBase(),
			      this.getParameter("sound"));
    // Mritelln tapahtumakuuntelijaolio, joka reagoi hiiren painikkeen
    // painalluksiin. Huomaa, ett tm ratkaisu on Java 1.1 
    // tapahtumaksittelymallin mukainen. Tss kytetn mys Java 1.1-
    // versiossa mahdollista sisemp luokkaa, jollainen on mritelty alla.
    this.addMouseListener(new Listener());
  }
  /** Tt kutsutaan kun applettia ollaan poistamassa jrjestelmst.
   * Tss metodia kytetn tarpeettomaksi jvn kuvan poistamiseen.
   * Ratkaisulla saatetaan mahdollistaa muistin ja muiden resurssien
   * vapautuminen nopeammin. */
  public void destroy() { image.flush(); }
  /** Appletti nytetn yksinkertaisesti vain piirtmll kuva */
  public void paint(Graphics g) { g.drawImage(image, 0, 0, this); }
  /** Tm metodi on korvattu siksi, ett metodi ei tyhjentisi taustaa ennen
   * paint()-kutsua. Taustaa ei tarvitse tyhjent, koska paint()-metodissa
   * peitetn koko alue kuvalla. Nin appletti vilkkuu vhemmn */
  public void update(Graphics g) { paint(g); }
  /** Jsennelln pilkuilla erotettu suorakaide- ja URL-luettelo.
   * Tll metodilla luetaan linkkikuvan suorakaidemrittelyt appletin 
   * parametreista */
  protected ImagemapRectangle getRectangleParameter(String name) {
    int x, y, w, h;
    URL url;
    String value = this.getParameter(name);
    if (value == null) return null;
    try {
      StringTokenizer st = new StringTokenizer(value, ",");
      x = Integer.parseInt(st.nextToken());
      y = Integer.parseInt(st.nextToken());
      w = Integer.parseInt(st.nextToken());
      h = Integer.parseInt(st.nextToken());
      url = new URL(this.getDocumentBase(), st.nextToken());
    }
    catch (NoSuchElementException e) { return null; }
    catch (NumberFormatException e) { return null; }
    catch (MalformedURLException e) { return null; }
    return new ImagemapRectangle(x, y, w, h, url);
  }
  /**
   * Tmn sisemmn luokan tyyppisell oliolla ksitelln hiiritapahtumat.
   */
  class Listener extends MouseAdapter {
    /** Suorakaide, jonka alueella hiirell painettiin. */
    private ImagemapRectangle lastrect;
    /** Tt kutsutaan kun painetaan hiiren painiketta. */
    public void mousePressed(MouseEvent e) {
      // Kun nappi painetaan alas, katsotaan ollaanko jonkin mritellyn 
      // suorakaiteen sisll. Jos nin on, korostetaan suorakaide, nytetn 
      // ilmoitus ja soitetaan ni. Apumetodi findrect() on mritelty alla.
      ImagemapRectangle r = findrect(e);
      if (r == null) return;
      Graphics g = Applet.this.getGraphics();
      g.setXORMode(Color.red);
      g.drawRect(r.x, r.y, r.width, r.height);  // Korostetaan suorakaide
      Applet.this.showStatus("To: " + r.url);   // Nytetn URL
      sound.play();                             // Soitetaan ni
      lastrect = r;   // Pannaan suorakaide muistiin, jotta korostuksen voi
    }                 // poistaa
    /** Tt kutsutaan, kun hiiren painike pstetn yls. */
    public void mouseReleased(MouseEvent e) {
      // Kun hiiren painike pstetn yls, poistetaan korostus. Jos hiiri 
      // on yh suorakaiteen sisll, pyydetn selainta siirtymn 
      // vastaavaan URL-osoitteeseen.
      if (lastrect != null) {
		Graphics g = Applet.this.getGraphics();
		g.setXORMode(Color.red);
		g.drawRect(lastrect.x, lastrect.y, lastrect.width, lastrect.height);
		Applet.this.showStatus("");   // Poistetaan ilmoitus.
		ImagemapRectangle r = findrect(e);
		if ((r != null) && (r == lastrect))  // Jos yh sama suorakaide,
	  		Applet.this.getAppletContext().showDocument(r.url); // mennn 
		lastrect = null;                              // osoitteeseen.
      }
    }
    /** Selvitetn suorakaide, jonka sisll ollaan. */
    protected ImagemapRectangle findrect(MouseEvent e) {
      int i, x = e.getX(), y = e.getY();
      for(i = 0; i < rects.size(); i++)  {
		ImagemapRectangle r = (ImagemapRectangle) rects.elementAt(i);
		if (r.contains(x, y)) return r;
      }
      return null;
    }
  }
  /**
   * Apuluokka. Samanlainen kuin java.awt.Rectangle paitsi ett 
   * tss on mukana URL-kentt.
   * Huomaa, miten siskkisill ptason luokilla saa siistimmn ratkaisun.
   */
  static class ImagemapRectangle extends Rectangle {
    URL url;
    public ImagemapRectangle(int x, int y, int w, int h, URL url) {
      super(x, y, w, h);
      this.url = url;
    }
  }
}