import java.applet.*;
import java.awt.*;
import java.awt.event.*;
public class Scribble4 extends Applet {
  private int lastx, lasty;
  /** Kerrotaan jrjestelmlle, ett ollaan kiinnostuneita hiiritapahtumista,
   *  hiiren liikkeist kertovista tapahtumista ja nppintapahtumista.
   *  Nin tytyy tehd, tai tapahtumia ei lhetet.
   */
  public void init() {
    this.enableEvents(AWTEvent.MOUSE_EVENT_MASK |
                      AWTEvent.MOUSE_MOTION_EVENT_MASK |
                      AWTEvent.KEY_EVENT_MASK);
    this.requestFocus();  // Pyydetn fokus, jotta saataisiin 
                          // nppintapahtumia
  }
  /** Tt kutsutaan, kun tapahtuu jonkinlainen hiiritapahtuma */
  public void processMouseEvent(MouseEvent e) {
    if (e.getID() == MouseEvent.MOUSE_PRESSED) {  // Tutkitaan tapahtuman 
      lastx = e.getX(); lasty = e.getY();          // tyyppi
    }
    else super.processMouseEvent(e); // Ksittelemtt jtetyt tapahtumat 
  }                                  // annetaan yliluokalle.
  /** Tt kutsutaan, kun tapahtuu hiiren liikkeest kertova tapahtuma */
  public void processMouseMotionEvent(MouseEvent e) {
    if (e.getID() == MouseEvent.MOUSE_DRAGGED) {  // Tutkitaan tyyppi
      int x = e.getX(), y = e.getY();
      Graphics g = this.getGraphics();
      g.drawLine(lastx, lasty, x, y);
      lastx = x; lasty = y;
    }
    else super.processMouseMotionEvent(e);
  }
  /** Tt kutsutaan, kun tapahtuu nppintapahtuma:
   *  tyhjennetn nytt, kun painetaan 'c'-nppint.
   */
  public void processKeyEvent(KeyEvent e) {
    if ((e.getID() == KeyEvent.KEY_TYPED) && (e.getKeyChar() == 'c')) {
      Graphics g = this.getGraphics();
      g.setColor(this.getBackground());
      g.fillRect(0, 0, this.getSize().width, this.getSize().height);
    }
    else super.processKeyEvent(e); // Ksittelemtt jtetyt tapahtumat annetaan
  }                                // yliluokalle.
}