import java.io.*;
/** Yksinkertainen luokka, joka vastaa dynaamisesti kasvavaa int-taulukkoa, 
 *  ja joka osaa serialisoidan itsens yht tehokkaasti kuin kiinten 
 *  kokoinen taulukko. 
 */
public class IntList implements Serializable
{
  // Taulukko, johon luvut viedn.
  private int[] nums = new int[8]; 
  // Ensimmisen kyttmttmn alkion indeksi.
  private transient int size = 0;  
  /** Palauttaa taulukon alkion */
  public int elementAt(int index) throws ArrayIndexOutOfBoundsException {
    if (index >= size) throw new ArrayIndexOutOfBoundsException(index);
    else return nums[index];
  }
  /** Lis taulukkoon int-luvun ja kasvattaa taulukkoa jos tarvitsee */
  public void add(int x) {
  // Kasvatetaan taulukkoa
    if (nums.length == size) resize(nums.length*2); 
    nums[size++] = x;                                // Talletetaan int-luku.
  }
  /** Sisinen metodi, jolla muutetaan taulukon kokoa */
  protected void resize(int newsize) {
    int[] oldnums = nums;
    nums = new int[newsize];                     // Luodaan uusi taulukko.
    System.arraycopy(oldnums, 0, nums, 0, size); // Kopioidaan taulukon 
  }                                              // alkiot.
  /** Hankkiudutaan eroon kyttmttmist alkioista ennen serialisointia */
  private void writeObject(ObjectOutputStream out) throws IOException {
    if (nums.length > size) resize(size);  // Tiivistetn taulukko.
    out.defaultWriteObject();              // Ja kirjoitetaan se sitten 
  }                                        // normaalisti.
  /** Lasketaan tarnsientin size-kentn arvo sen jlkeen kun olio on 
   *palautettu. 
   */
  private void readObject(ObjectInputStream in)
          throws IOException, ClassNotFoundException {
    in.defaultReadObject();                // Luetaan taulukko.
    size = nums.length;                    // Annetaan arvo taulukon koolle.
  }
} 