package oreilly.beans.yesno;
import java.beans.*;
import java.awt.*;
import java.awt.event.*;
/**
 * Tm luokka on itse tehty editori YesNoDialog-komponentin message-
 * ominaisuuden muokkaamista varten. Editoria tarvitaan, koska merkkijonojen
 * muokkaamiseen kytettv oletuseditori ei mahdollista monirivisten
 * merkkijonojen syttmist.
 */
public class YesNoDialogMessageEditor implements PropertyEditor {
  protected String value;  // Arvo, jota muokataan.
  public void setValue(Object o) {  value = (String) o; }
  public Object getValue() { return value; }
  public void setAsText(String s) { value = s; }
  public String getAsText() { return value; }
  public String[] getTags() { return null; }  // Ei ole luettelo-ominaisuus.
  // Kerrotaan, ett tuemme omaa editoria.
  public boolean supportsCustomEditor() { return true; }
  // Luodaan oma editori. Tss vain luodaan ja palautetaan TextArea, jossa
  // monirivist teksti muokataan. Metodissa mys rekisteridn 
  // tekstialuetta kuunteleva olio, jolla pivitetn ominaisuuden arvo sit 
  // mukaa kun kyttj kirjoittaa teksti ja jossa lhetetn 
  // ominaisuusmuutossanomat niin kuin ominaisuuseditoreissa pit tehd.
  public Component getCustomEditor() {
    final TextArea t = new TextArea(value);
    t.setSize(300, 150); // TextArea-komponentilla ei ole oletusarvoisesti 
                         // sopivaa kokoa joten valitaan jokin koko.
    t.addTextListener(new TextListener() {
      public void textValueChanged(TextEvent e) {
        value = t.getText();
        listeners.firePropertyChange(null, null, null);
      }
    });
    return t;
  }

  // Arvon nkyv versio, jota kytetn editorissa. Nytetn ohjeita ja
  // toivotaan, ett ne mahtuvat kehykseen. Ratkaisu voisi olla 
  // kehittyneempikin.
  public boolean isPaintable() { return true; }
  public void paintValue(Graphics g, Rectangle r) {
    g.setClip(r);
    g.drawString("Click to edit...", r.x+5, r.y+15);
  }

  // Koodigeneraattoreille trke metodi. Huomaa, ett vastauksessa
  // pit olla mukana mahdollisesti tarvittavat koodimerkit.
  public String getJavaInitializationString() { return "\""+value+"\""; }

  // Tss kytetn PropertyChangeSupport-luokkaa, jolla pidetn kirjaa
  // arvoon tehtvist muutoksista kiinnostuneista olioista.
  protected PropertyChangeSupport listeners = new 
                                                PropertyChangeSupport(this);
  public void addPropertyChangeListener(PropertyChangeListener l) {
    listeners.addPropertyChangeListener(l);
  }
  public void removePropertyChangeListener(PropertyChangeListener l) {
    listeners.removePropertyChangeListener(l);
  }
}