package oreilly.beans.yesno;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;
/**
 * Tm luokka on YesNoDialog-komponentin asetuseditori. Siin nytetn 
 * TextArea-komponentti ja kolme TextField-kentt, joihin kyttj voi sytt
 * dialogissa nytettvn ilmoituksen sek kaikkien kolmen napin otsikot.
 * Editorilla ei voi muuttaa dialogin otsikkoa tai muita resursseja.
 */
public class YesNoDialogCustomizer extends Panel
                                   implements Customizer, TextListener
{
  protected YesNoDialog bean;                 // Muokattava komponentti.
  protected TextComponent message, fields[];  // Editorin  komponentit.
  // Oletuskonstruktori: YesNoDialogCustomizer() { super(); }
  // Komponenttien ksittelyohjelma kutsuu tt metodia kun se kertoo, mit 
  // oliota on tarkoitus muokata. Tm metodia kutsutaan aina ennen kuin 
  // editori tuodaan nkyviin joten editorin kyttliittymn voi luoda tss 
  // metodissa.
public void setObject(Object o) {
    bean = (YesNoDialog)o;   // Laitetaan muokattava olio talteen.
    // Laitetaan paneelin ylosaan otsikko.
    this.setLayout(new BorderLayout());
    this.add(new Label("Enter the message to appear in the dialog:"), 
                       "North");
    // Listn sen alle tekstialue, johon voi kirjoittaa ilmoituksen.
    message = new TextArea(bean.getMessage());
    message.addTextListener(this);
    // TextArea-olio ei tied itselleen sopivaa kokoa joten se pit kertoa.
    message.setSize(400, 200);
    this.add(message, "Center");
    // Listn tekstikenttrivej, joihin kirjoitetaan nappien otsikot.
    Panel buttonbox = new Panel();                     // Rivisili.
    buttonbox.setLayout(new GridLayout(1, 0, 25, 10)); // Kentt tasavlein.
    this.add(buttonbox, "South");                      // Laitetaan rivi 
                                                       // alalaitaan.

    // Luodaan kolme TextField-oliota, jotka tlle riville laitetaan. 
    // Jokaisen kentn ylle laitetaan Label-oliolla otsikko, joten luodaan 
    // silit kutakin TextField+Label-yhdistelm varten.
    fields = new TextComponent[3];           // TextFields-taulukko.
    String[] labels = new String[] {         // Kunkin kentn otsikot.
      "Yes Button Label", "No Button Label", "Cancel Button Label"};
    String[] values = new String[] {         // Alkuarvot.
      bean.getYesLabel(), bean.getNoLabel(), bean.getCancelLabel()};
    for(int i = 0; i < 3; i++) {
      Panel p = new Panel();                 // Luodaan sili.
      p.setLayout(new BorderLayout());       // Asetellaan BorderLayout-
                                             // oliolla.
      p.add(new Label(labels[i]), "North");  // Laitetaan otsikko yllaitaan.
      fields[i] = new TextField(values[i]);  // Luodaan tekstikentt.
      p.add(fields[i], "Center");            // Laitetaan se otsikon 
                                             // alapuolelle.
      fields[i].addTextListener(this);       // Asetetaan 
                                             // tapahtumakuuntelija.
      buttonbox.add(p);                      // Listn sili riviin.
    }
  }
  // Listn hieman tilaa paneelin ulkoreunojen ymprille.
  public Insets getInsets() { return new Insets(10, 10, 10, 10); }
  // Tm on TextListener-rajapinnassa mritelty metodi. Aina kun TextArea-
  // tai TextFields-olioon kirjoitetaan jotain, tt metodia kutsutaan.
  // Metodi pivitt komponentin vastaavan ominaisuuden ja lhett 
  // ominaisuuden muutosilmoitustapahtuman niin kuin asetuseditoreissa pit 
  // tehd. Huomaa, ett jokaisesta nppimenpainalluksesta ei tarvitse 
  // lhett ilmoitusta. Yht hyvin voitaisiin tehd "Apply" (kyt) -nappi, 
  // jolla muutokset hyvksytn kerralla jolloin ominaisuuden 
  // muutostapahtuma lhetettisiin vain kerran.
  public void textValueChanged(TextEvent e) {
    TextComponent t = (TextComponent)e.getSource();
    String s = t.getText();
        if (t == message) bean.setMessage(s);
    else if (t == fields[0]) bean.setYesLabel(s);
    else if (t == fields[1]) bean.setNoLabel(s);
    else if (t == fields[2]) bean.setCancelLabel(s);
    listeners.firePropertyChange(null, null, null);
  }
  // Tss kytetn hyvksi PropertyChangeSupport-luokkaa. Oliolla pidetn
  // kirjaa komponentille tehtvist muutoksista kiinnostuneista 
  // kuuntelijoista.
  protected PropertyChangeSupport listeners = new PropertyChangeSupport(this);
  public void addPropertyChangeListener(PropertyChangeListener l) {
    listeners.addPropertyChangeListener(l);
  }
  public void removePropertyChangeListener(PropertyChangeListener l) {
    listeners.removePropertyChangeListener(l);
  }
}