import java.io.*;
/** Ohjelma, jolla muunnetaan teksti merkistst toiseen */
public class ConvertEncoding {
  public static void main(String[] args) {
    String from = null, to = null;
    String infile = null, outfile = null;
    for(int i = 0; i < args.length; i++) {  // Jsennelln 
                                            // komentoriviargumentit.
      if (i == args.length-1) usage();     // Argumentilla pit olla pari.
      if (args[i].equals("-from")) from = args[++i];
      else if (args[i].equals("-to")) to = args[++i];
      else if (args[i].equals("-in")) infile = args[++i];
      else if (args[i].equals("-out")) outfile = args[++i];
      else usage();
    }
    try { convert(infile, outfile, from, to); }  // Yritetn muunnosta.
    catch (Exception e) {                        // Ksitelln mahdollinen 
                                                 // poikkeus.
      LocalizedError.display(e);  // Mritelty tmn luvun lopussa.
      System.exit(1);
    }
  }
  public static void usage() {
    System.err.println("Usage: java ConvertEncoding <options>\n" +
                       "Options: \n\t-from <encoding> \n\t-to <encoding> \n\t" +
                       "-in <file>\n\t-out <file>");
    System.exit(1);
  }
  public static void convert(String infile, String outfile,
                             String from, String to)
       throws IOException, UnsupportedEncodingException
  {
    // Luodaan tavuvirrat.
    InputStream in;
    if (infile != null) in = new FileInputStream(infile);
    else in = System.in;
    OutputStream out;
    if (outfile != null) out = new FileOutputStream(outfile);
    else out = System.out;
    // Kytetn oletusmerkist ellei merkist ole erikseen mritelty.
    if (from == null) from = System.getProperty("file.encoding");
    if (to == null) to = System.getProperty("file.encoding");
    // Luodaan merkkivirrat.
    Reader r = new BufferedReader(new InputStreamReader(in, from));
    Writer w = new BufferedWriter(new OutputStreamWriter(out, to));
    // Kopioidaan merkit sytevirrasta tulosvirtaan. InputStreamReader-olio 
    // muuntaa syttmerkistst Unicode-merkistn ja OutputStreamWriter-
    // olio muuntaa Unicode-merkistst tulosmerkistn. Merkit, joita ei 
    // voi esitt tulosmerkistss, muunnetaan ?-merkeiksi.
    char[] buffer = new char[4096];
    int len;
    while((len = r.read(buffer)) != -1)  // Luetaan dataa.
      w.write(buffer, 0, len);           // Ja kirjoitetaan se ulos.
    r.close();                           // Suljetaan sytevirta.
    w.flush();                           // Tyhjennetn ja suljetaan 
    w.close();                           // tulosvirta.
  }
}