/* 
	VlittHTML-sivulta parametrina saadun tekstirivin
	appletin nytlle ajettavaksi.
*/


import java.awt.*;

public class Varoitus extends javax.swing.JApplet

    implements Runnable {

    String text = "Teksti ei vlitetty";
    
    float hue = (float) 0.5;
    float saturation = (float) 0.8;
    float brightness = (float) 0.0;
    
    Font textFont = new Font("Dialog", Font.BOLD, 20);
    int textX;
   
    Thread runner;  // Kynnistettv sie

    public void init() {
        setBackground(Color.black);  // Taustavri
        String paramName = getParameter("TEXT"); // HTML-parametri
        if (paramName != null)  // Jos parameti erisuu kuin tyh niin
            text = paramName;  // sijoita parametri tekstiin
        FontMetrics fm = getFontMetrics(textFont); // Perusta fonttia vastaava mitoitusmuuttuja
        textX = getSize().width / 2 - fm.stringWidth(text) / 2; // Laske tekstin koko
   }

    // Tulostaa nyttruudun
    public void paint(Graphics screen) {
        Graphics2D screen2D = (Graphics2D) screen;
        
        // Kirkkausarvot muuttuvat koko ajan
        Color textColor = Color.getHSBColor(hue, saturation,
            brightness); // Mrit vrimuuttuja RGB arvojen mukaan
        
        screen2D.setColor(textColor);  // ksittele tulostusta 2D-muodossa
        screen2D.setFont(textFont);
        screen2D.drawString(text, textX, 30);
    }

    // Kutsutaan ruudun pivitysmetodia paint
    public void update(Graphics screen) {
        paint(screen);
    }

    // Luodaan pausemetodi, jossa mrtn kauanko si runner huilaa.
    void pause(int kesto) {
        try {  // thehdn aina jos vaan mahdollista. (Ei keskeytetty)
            Thread.sleep(kesto);
        } catch (InterruptedException e) {
        	// TODO: Lis keskeytysmetodit myhemmin 
        	} 
    }

    // Kynnistysmetodi sikeen Thread runner mukaan
    public void start() {
        if (runner == null) {			// Sikeen luonti/kynnistys
            runner = new Thread(this);	// this= On applettiin viittaava parametri Ei
            runner.start();				// esimerkiksi metodin sie.
        }
    }

    // Appletin pysytysmetodi
    public void stop() {
        if (runner != null) {
            runner = null;
        }
    }

    
    // Appletin suorituksen kynnistysmetodi
    public void run() {
        Thread thisThread = Thread.currentThread();
        while (runner == thisThread) {		// ANIMAATION TOTEUTUSLOOPPI
            pause(35);						// Uinumistauko millisekunteina
            brightness += 0.05;
            if (brightness > 1) {
                brightness = (float) 0.0;
                pause(75);
            }
            repaint();						// Pivit ruutu uinumisen loputtua
        }
    }
}

