import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

/** 
* OstoskoriTulostus.java
* Ohjelmassa listn HTML-sivulla annetut tuotteet
* HttpSession-olioon.
* HttpSession-olioon listn seuraavat tuotteet
*  Avain: ostoksia - tuotteiden lukumr
*  avain: TuoteX - tuote1, tuote2, tuote3 jne.
* Tekij: Juha Peltomki.
*/

public class OstoskoriTulostus extends HttpServlet {

    private String htmlUrl = "../Ostoskori.html";

    public void doPost(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException  {

		PrintWriter out = res.getWriter();
		res.setContentType("text/html");
		out.println("<html><head><title>Ostoskorissa olevat tuotteet</title></head>");
		out.println("<body>");
		out.println("<h1>Ostoskorin sislt</h1>");

		tulostaKori(req, out);

		tulostaLinkit(res, out);
		out.println("</body></html>");
	 }

     public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException  {
            doPost(req, res);
     }

     private void tulostaKori(HttpServletRequest req, PrintWriter out) {
        HttpSession session = req.getSession();
        out.println("ID:    " + " " + session.getId() + "<br/>");
        out.println("Luotu: " + " " + new Date(session.getCreationTime()) + "<br/>");
        out.println("Kyty: " + " " + new Date(session.getLastAccessedTime()) + "<br/>");

        out.println("<table border='1'>");

	Ostoskori ostoskori =  (Ostoskori)session.getAttribute("ostoskori");

	Enumeration ostokset = ostoskori.getTilaukset().elements();
	
        while (ostokset.hasMoreElements()) {
            String ostos = (String)ostokset.nextElement(); 
            out.println("<tr><td>" + ostos + "</td></tr>");
        }
        out.println("</table>");
	}

	private void tulostaLinkit(HttpServletResponse res, PrintWriter out) {
        out.print("<div><a href='");
		out.println(res.encodeURL(htmlUrl));
		out.println("'>Tuotteen lisys ostoskoriin</a></div>");
	}

}














