import java.io.*;
import java.sql.*;

public class jdbcTesti {

  static String ajuri = "sun.jdbc.odbc.JdbcOdbcDriver";
  static String url = "jdbc:odbc:JDBCHenkilot";

  private static String kysely[] = {
     "INSERT INTO henkilotiedot (Nimi,Osoite, SPosti, Ika, Paivitetty)" +
     " VALUES ('Jaska Jokunen','Jokusentie 4as10'," + 
     "'jaska@jokunen.net','14','31.7.2001')",
     "UPDATE henkilotiedot SET sposti='jaska@jokusen.verkko.net'" +
     " WHERE nimi='Jaska Jokunen'"
   };

  private static String select[] = {
     "select * from henkilotiedot",
     "select * from henkilotiedot where nimi like ?"
   };


  //************** Pohjelma **************************
  public static void main(String[] args){ // throws SQLException {
    // **** Muodostetaan yhteys tietokontaan (Connection-olio) ************
    Connection con = HenkiloTietokanta.yhdista(ajuri, url);
    if (con == null) { System.exit(0); }
    int palautus=0;

    //**** Kannan tietojen muokkaus (sql insert/update) ******

    try {
//      palautus = HenkiloTietokanta.paivita(con, kysely[0]);
      palautus = HenkiloTietokanta.paivita(con, kysely[1]);
    } catch (SQLException sqle) {
        while (sqle != null) { 
          System.out.println(sqle.toString());
          sqle = sqle.getNextException();
        }
      }
      catch (Exception sqle) {
         System.out.println(sqle.toString());
      }
    System.out.println("Tietokantaan tehtiin " + palautus + " pivityst");
    

    //**** Kysely (sql select)******
    try {
      System.out.println("Kysely:" + select[0]);
      Statement stmt = con.createStatement();
      ResultSet rs = stmt.executeQuery(select[0]);
      HenkiloTietokanta.kysely(rs);  
      stmt.close();
    } catch (SQLException sqle) {
        while (sqle != null) { 
          System.out.println(sqle.toString());
          sqle = sqle.getNextException();
        }
    }
     
   //**** Kysely - Prepared Statement **********
   // Parametri tuodaan komentorivill
 
   try {
      PreparedStatement pstmt = con.prepareStatement(select[1]);
      pstmt.setString(1, args[0]);
      ResultSet rs = pstmt.executeQuery();
      HenkiloTietokanta.kysely(rs);  
      pstmt.close();
   } catch (ArrayIndexOutOfBoundsException ae) {
       System.out.println("Anna hakunimi komentorivill!");  
     }
     catch (SQLException sqle) {
        while (sqle != null) { 
          System.out.println(sqle.toString());
          sqle = sqle.getNextException();
        }
    }
    // Suljetaan yhteys lopuksi
    try {
       if (con != null)  con.close();
    } catch (SQLException e) { }


  }
}
