package HenkTk;

import java.sql.*;
import java.util.Vector;
import java.io.*;
import javax.servlet.jsp.*;


/**
Sislt staattisia metodeita, joilla voi tehd kyselyit henkiltietokantaan.

Connection yhdista(JDBCajuri, url)
void kysely(con, sqlLause)
void kyselyHTML(con, sqlLause)
int paivita(con, sqlLause)

*/

public class HenkiloTietokanta {

  /** 
  Metodi lataa ajurin ja ottaa yhteyden toisena parametrin
  annettuun url-osoitteeseen. url on joko DSN tai URL.
  Palauttaa Connection-olion tai null, jos yhteyden muodostaminen
  ei onnistunut.
  */  

  //*********************************************
  public static Connection yhdista(String JDBCajuri, String url) {
    try {
      Class.forName(JDBCajuri).newInstance();
      // avataan yhtetys
      Connection conn = DriverManager.getConnection(url);
      return conn;
     }
     catch (SQLException e) {
       System.out.println("Yhteys ei muodostunut:" + e);
       return null;
     }
     catch (ClassNotFoundException e) {
       System.out.println("Ajuria ei lytynyt:" + e);
       return null;
     }
     catch (InstantiationException e) {
       System.out.println("Ajuria ei lytynyt:" + e);
       return null;
     }
     catch (IllegalAccessException e) {
       System.out.println("Ajuria ei lytynyt:" + e);
       return null;
     }
     
  } 

  //*********************************************

  //*********************************************
  public static void kysely(ResultSet rs) throws SQLException {
    // ResultSetMetaData sislt tietoa kannan kentist
    ResultSetMetaData metaData = rs.getMetaData();

    for (int i = 1; i <= metaData.getColumnCount(); ++i)
      System.out.print(metaData.getColumnName(i) + " ");
    System.out.println();
    System.out.println("-------------------------------------------------------------");


    /* ResultSet-olion tulostaminen */
    while (rs.next()) {
      for (int i = 1; i <= metaData.getColumnCount(); ++i) {
        String data = rs.getString(i);
        if (data == null) data = "null";
        System.out.print(data.trim() + "\t");
      }
      System.out.println();
    }
  }


  //*********************************************
  public static void kyselyHTML(ResultSet rs, PrintWriter out) throws SQLException {
    // ResultSetMetaData sislt tietoa kannan kentist
    ResultSetMetaData metaData = rs.getMetaData();

	out.println("<table border='1'><tr>");
    for (int i = 1; i <= metaData.getColumnCount(); ++i)
      out.print("<th>" + metaData.getColumnName(i) + "</th>");
	out.println("</tr>");

    /* ResultSet-olion tulostaminen */
    while (rs.next()) {
      out.println("<tr>");
      for (int i = 1; i <= metaData.getColumnCount(); ++i) {
        String data = rs.getString(i);
        if (data == null) data = "null";
        out.print("<td>" + data.trim() + "</td>");
      }
      out.println("</tr>");
    }
	out.println("</table>");
  }

  //*********************************************
  // JSP:n kyttm metodi 
  public static void kyselyHTML(ResultSet rs, javax.servlet.jsp.JspWriter out) throws SQLException, IOException {
    // ResultSetMetaData sislt tietoa kannan kentist
    ResultSetMetaData metaData = rs.getMetaData();

	out.println("<table border='1'><tr>");
    for (int i = 1; i <= metaData.getColumnCount(); ++i)
      out.print("<th>" + metaData.getColumnName(i) + "</th>");
	out.println("</tr>");

    /* ResultSet-olion tulostaminen */
    while (rs.next()) {
      out.println("<tr>");
      for (int i = 1; i <= metaData.getColumnCount(); ++i) {
        String data = rs.getString(i);
        if (data == null) data = "null";
        out.print("<td>" + data.trim() + "</td>");
      }
      out.println("</tr>");
    }
	out.println("</table>");
  }


  //*********************************************
  /** 
  Metodilla muutetaan tietokantaa parametrin annetun
  SQL-kyselyn perusteella. Palauttaa muutettujen 
  tietueiden lukumrn */

  public static int paivita(Connection con, String sqlLause)
    throws SQLException, ClassNotFoundException,
           IllegalAccessException, InstantiationException  {   
    Statement stmt = con.createStatement();
    System.out.println("Suoritetaan lause: " + sqlLause);
    //Suoritetaan lause ja kertn tiedot merkkijonoon.
    int tulos = stmt.executeUpdate(sqlLause);
    stmt.close();
    return tulos;
  }

}

  


