import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.sql.*;
import HenkTk.*; // HenkiloTietokanta-luokka	

/** 
* LueHenkTk.java
* Lukee Henkilot-tietokantaa.
* Parametri annetaan HTML-lomakkeella (nimi).
* Tietokantatulosten esittminen: HenkiloTietokanta.kyselyHTML(rs, out);  
* Tekij: Juha Peltomki.
*/

public class LueHenkTk extends HttpServlet {

    private static String htmlUrl = "../servlets/LueHenkTk.html";

  	static String ajuri = "sun.jdbc.odbc.JdbcOdbcDriver";
  	static String url = "jdbc:odbc:HenkiloServlet";

	 public void doPost(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException  {

		boolean virheita = false;
        String nimi = req.getParameter("nimi");
        if (nimi == null || nimi.trim().equals("") )
			virheita=true;

        res.setContentType("text/html");
		// Ei ladata sivua vlimuistiin HTTP 1.0 ja 1.1
		res.setHeader("Pragma", "no-cache");
		res.setHeader("Cache-Control", "no-cache");

        PrintWriter out = res.getWriter();
        out.println("<html><body>");
        out.println("<h1>Tietokantahaun tulokset</h1>");
		
        out.println("</table>");
		if (virheita)
			out.println("<div style='color:red'>Hakuparametri nimi puuttui</div>");
		else
			// Suoritetaan tietokantakysely
			teeKysely(out,nimi);

		tulostaLinkit(res,out);
		out.println("</body></html>");
	 }

   	 public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException  {
            doPost(req, res);
     }


	// Tehdn tietokantakysely
	private void teeKysely(PrintWriter out, String nimi) {
		String select = "select * from henkilotiedot where nimi like ?";

		// **** Muodostetaan yhteys tietokontaan (Connection-olio) ************
		Connection con = HenkiloTietokanta.yhdista(ajuri, url);
		if (con == null) { System.exit(0); }
   
		//**** Kysely - Prepared Statement **********
		// Parametri tuodaan HTML-lomakkeella
 
		try {
			PreparedStatement pstmt = con.prepareStatement(select);
			pstmt.setString(1, '%' + nimi + '%');
			ResultSet rs = pstmt.executeQuery();
			HenkiloTietokanta.kyselyHTML(rs, out);  
			pstmt.close();
		} catch (ArrayIndexOutOfBoundsException ae) {
			out.println("Anna hakunimi komentorivill!\n" + ae.toString());  
		}
		catch (SQLException sqle) {
			while (sqle != null) { 
				out.println("<div>" + sqle.toString() + "</div>");
				sqle = sqle.getNextException();
			}
		}

		// Suljetaan yhteys lopuksi tietokantaan.
		try {
    	   if (con != null)  con.close();
	    } catch (SQLException e) { }
	}


	private void tulostaLinkit(HttpServletResponse res, PrintWriter out) {
        out.print("<div><a href='");
		out.println(res.encodeURL(htmlUrl));
		out.println("'>Takaisin syttlomakkeelle</a></div>");
	}

	private String tr(String muuttuja, String arvo) {
        String mj = "<tr><td>" + muuttuja + "</td>";
        return mj + "<td>" + arvo + "</td></tr>";
	}

}
