/*
  Tiedosto: SanakirjaTesti.java
  Tekij:   Juha Peltomki.
  Aihe:     Englanti-Suomi -sanakirja, johon voi list sanoja ja josta voi
            hakea tai poistaa sanoja.
*/

import java.util.*;

/**
  Sanakirja-luokan metodit:
   etsi(String)
   lisaa(String, String)
   poista(String)
   tulosta() - tulostaa
*/
class Sanakirja
{
   private Hashtable sanasto;

   Sanakirja() {
     sanasto = new Hashtable();
   }

   Sanakirja(int koko) {
     sanasto = new Hashtable(koko);
   }


   /* Metodilla listn sanakirjaan alkio */
   public void lisaa(String eng, String fin) {
     sanasto.put(eng, fin);
   }

   /* Metodilla Poistetaan sanakirjasta alkio */
   public String poista(String haettava) {
     String poistettu = "";
     poistettu =(String)sanasto.remove(haettava);
     return poistettu;
   }

   public String etsi(String hakusana) {
     String haettava = (String)sanasto.get(hakusana);
     return haettava;
   }

   public void tulosta() {
     for (Enumeration at=sanasto.keys(); at.hasMoreElements(); ) {
       String avain = (String) at.nextElement();
       System.out.println(avain + ":" + sanasto.get(avain));
     }
   }
}

/***************************************************************************/

public class SanakirjaTesti {
   /** Pohjelmalla testataan sanakirja-luokan toimintaa */

   public static void main(String args[])
   {

     Sanakirja tietokonetermit = new Sanakirja();
     tietokonetermit.lisaa("object", "olio");
     tietokonetermit.lisaa("computer","tietokone");
     tietokonetermit.lisaa("program","ohjelma");
     tietokonetermit.lisaa("programming","ohjelmointi");
     tietokonetermit.lisaa("system","jrjestelm");
     tietokonetermit.lisaa("compiler","kntj");
     tietokonetermit.lisaa("linker","linkittj");
     tietokonetermit.lisaa("interpreter","tulkki");
     tietokonetermit.lisaa("byte-code","tavukoodi");
     tietokonetermit.lisaa("execute","suorittaa");

     System.out.println("object: " + tietokonetermit.etsi("object"));
     System.out.println("byte-code: " + tietokonetermit.etsi("byte-code"));
     tietokonetermit.poista("byte-code");
     System.out.println("byte-code: " + tietokonetermit.etsi("byte-code"));

     System.out.println("***************************************************");
     tietokonetermit.tulosta();

   }
}
