/**
  Tiedosto: TuoteTesti.java
  Tekij:   Juha Peltomki.
  Aihe:     Tuoteluettelo, johon listn tuotteita.
            Tuotteilla on nimi ja hinta.
*/

import java.util.*;

/***************************************************************************/
/**
 Tuote-luokan metodit:
   aseta(nimi, hinta)
   toString()
*/

class Tuote {
  double hinta;
  String nimi;

  Tuote(String nimi, double hinta) {
     this.aseta(nimi, hinta);
  }

  public void aseta(String nimi, double hinta) {
     if (hinta>0)
        this.hinta = hinta;
     if (nimi.length()>0)
        this.nimi = nimi;
  }

  public String toString() {
     return nimi + ": " + hinta + " mk";
  }

  public String nimi() { return nimi; }
  public double hinta() { return hinta; }

}
/***************************************************************************/

/**
 Tuotteet-luokan metodit:
   etsi_hinta(String)
   lisaa(Tuote)
   tulosta() - tulostaa
*/

class Tuotteet
{
   private Vector tuotteet;

   Tuotteet() {
     tuotteet = new Vector();
   }

   Tuotteet(int koko) {
     tuotteet = new Vector(koko);
   }

   /* Metodilla listn Vektoriin uusi tuote */
   public void lisaa(Tuote t) {
     tuotteet.addElement(t);
   }

   /* Palautetaan tuotteen hinta */
   public double etsi_hinta(String hakunimi) {
     for (int i=0; i<tuotteet.size(); i++) {
       Tuote tuote = (Tuote)tuotteet.elementAt(i);
       if (hakunimi.equalsIgnoreCase(tuote.nimi()))
         return tuote.hinta();
     }
     return -1;
   }

   /* Tulosta kaikkien tuotteiden hinnat.
   */

   public void tulosta() {
      for (int i=0; i<tuotteet.size(); i++) {
        System.out.println(tuotteet.elementAt(i).toString());
      }
   }
}

/***************************************************************************/

public class TuoteTesti {
   /** Pohjelmalla testataan Tuotteet-luokan toimintaa */

   public static void main(String args[])
   {
     Tuotteet t = new Tuotteet();
     t.lisaa(new Tuote("maito", 5.00));
     t.lisaa(new Tuote("hernekeitto", 4.90));
     t.lisaa(new Tuote("makaroni", 5.50));
     t.lisaa(new Tuote("spaghetti", 6.50));
     t.lisaa(new Tuote("kalapuikot", 11.50));

     System.out.println("Maidon hinta: " + t.etsi_hinta("maito"));
     System.out.println("Makaronin hinta: " + t.etsi_hinta("makaroni"));

     System.out.println("***************************************************");
     t.tulosta();

   }
}
