/**
 TiedostoPoikkeus.java
  @author: Juha Peltomki
  Aihe:   IOException -luokan poikkeusten ksittely ja resurssien hallittu vapauttaminen.
*/

import java.io.FileReader;
import java.io.IOException;

public class TiedostoPoikkeus {

  public static final int END_OF_FILE = -1;

  public static void kasitteleTiedostoa(String tiedNimi) throws IOException {
    int merkki;
    StringBuffer mj = new StringBuffer();
    FileReader fr=null;
    try {
      fr = new FileReader(tiedNimi);
      merkki = fr.read();
      while (merkki != TiedostoPoikkeus.END_OF_FILE) {
        mj.append((char)merkki);
        merkki = fr.read();
      }
      System.out.println(mj.toString());
    }
    finally {
      System.out.println("Suljetaan tiedosto");
      if (fr != null) fr.close();
    }
  }

  public static void main(String args[])  {
    try {
       kasitteleTiedostoa(args[0]);
    }
    catch (IOException e) {
      System.out.println("IOException otettu kiinni!");
      e.printStackTrace();
    }
  }
}
