import java.awt.*;
import java.awt.event.*;

public class IkkunaKuuntelijaTesti {
  public static void main(String[] args) {
    new Ikkuna();
  }
}
//------------------------------------------------------
// Luodaan Listener-olion ja rekisteri kyseisen olion
// jolloin se saa tiedon, jos jokin kuunneltava tapahtuma 
// ilmenee.

class Ikkuna {
  public Ikkuna(){
    //Luodaan kehys ja asetetaan sille koko ja otsikko
    Frame kehys = new Frame();
    kehys.setSize(300,200);
    kehys.setTitle("Ikkunatesti, Juha Peltomki, 2001");
    
    // Luodaan Listener-olio
    IkkunaKuuntelija kuuntelija = new IkkunaKuuntelija(kehys);
    
    //Rekisteridn Listener-olio, jolloin ikkuna on tapahtuman lhde
    kehys.addWindowListener(kuuntelija);

    // Asetetaan ikkuna nkyville
    kehys.setVisible(true);
  }
}

//------------------------------------------------------
// Toteutetaan WindowListener-rajapinta, joka vaatii kaikkien
// rajapinnan metodien uudelleen toteutuksen.
// Tulostaa viestin, jos kyseinen tapahtuma havaitaan.

class IkkunaKuuntelija implements WindowListener {
  Frame win;
  
  IkkunaKuuntelija(Frame w){
    this.win = w;
  }

  public void windowClosed(WindowEvent we) {
     System.out.println("Viesti: Ikkuna on suljettu (close) mutta edelleen muistissa");
  } 

  public void windowIconified(WindowEvent we) {
    System.out.println("Viesti: Ikkunan pienennys ikoniksi (iconify)");
  }

  public void windowDeiconified(WindowEvent we){
    System.out.println("Viesti: ikoni takaisin ikkunaksi (deiconify)");
  }
  
  public void windowOpened(WindowEvent e){
    System.out.println("Viesti: Ikkuna avattiin (open)");
  }

  public void windowClosing(WindowEvent we) {
    System.out.println("Viesti: Ikkuna suljetaan ja tuhotaan muistista (closing)");
    win.dispose(); // Poistaa ikkunan muistista
    System.exit(0);
  }

  public void windowActivated(WindowEvent e){
    System.out.println("Viesti: Ikkuna aktivoituu (Activate)");
  }

  public void windowDeactivated(WindowEvent e){
    System.out.println("Viesti: Ikkuna ei aktiiviseksi (Deactivate)");
  }
}
