/*
    VaihtoehtoTesti.java
    Esimerkiss kaksi kysymyst ja vaihtoehdot
    kahdella erilaisella komponentill:
    a) Radiopainikkeet. (CheckBoxGroup-luokan oliot)
    b) Pudotusvalikko. (Choice-luokan oliot)

    Tekij: Juha Peltomki.
*/

import java.awt.*;
import java.swing.*;
import java.swing.event.*;
import java.awt.event.*;

public class VaihtoehtoTesti extends JApplet
{
   private JLabel kysymys1, kysymys2;
   private JCheckbox radio[] = new JCheckbox[4];
   private JCheckboxGroup radionapit;
   private JChoice valinnat;
   private JPanel kehys1;
   // oikeat vastauksen sisltv taulukko.
   private static final int oikea_vastaus[] = {2, 3};
   // Alustetaan kysymyksen_arvot.
   private String kehittaja[] = {"Nokia", "IBM", "Sun", "Compaq"};
   private int vuosiluku[] = {1970, 1981, 1990, 1995};

   public void init()
   {
      setBackground(Color.lightGray);

      // Luodaan radiopainikeryhm kysymyksineen.
      kysymys1  = new JLabel("Mik yhti kehitti Javan?");
      radionapit = new JCheckboxGroup();
      for (int i=0; i<radio.length; i++) {
        radio[i] = new JCheckbox(kehittaja[i], radionapit, false);
        radio[i].addItemListener(new RadioKuuntelija());
      }

      // Luodaan pudotusvalikkoryhm kysymyksineen.
      kysymys2  = new JLabel("Milloin ilmestyi ensimminen Java-kehitin?");
      valinnat = new JChoice();
      for (int i=0; i<vuosiluku.length; i++)
        valinnat.add(new Integer(vuosiluku[i]).toString());
      valinnat.addItemListener(new ListaKuuntelija());

      // Sijoitetaan elementit paneeleihin
      kehys1 = new JPanel();
      kehys1.setLayout(new GridLayout(8, 1));

      kehys1.add(kysymys1);
      for (int i=0; i<radio.length; i++)
        kehys1.add(radio[i]);
      kehys1.add(kysymys2);
      kehys1.add(valinnat);
      // Josta ne sijoitetaan lomakkeelle
      setLayout(new BorderLayout());

      // lisys Swing-kehykseen.
      kehys1.getContentPane().add(kehys1, BorderLayout.NORTH);
   }

/* Luokka ksittelee radiopainikkeiden tapahtumat. Luokka tarkastaa,
   oliko kohdeolio sama kuin oikea vastaus (radio[3]).
*/
   class RadioKuuntelija implements ItemListener {
      public void itemStateChanged(ItemEvent tapahtuma)
      {
         JCheckbox kohde = (JCheckbox) tapahtuma.getSource();

         if (kohde == radio[oikea_vastaus[0]])
            showStatus("Oikein! Tila: " + kohde.getState() + "  ja nimi ("
                       + kohde.getLabel() + ")");
         else
            showStatus("Vrin! Tila: " + kohde.getState() + " ja nimi ("
                       + kohde.getLabel() + ")");
      }
   }

  /* Luokka ksittelee listan valinnat. Trkein metodi on getSelectedIndex(),
     joka palauttaa valintalistan valitun alkion indeksinumeron.
  */
   class ListaKuuntelija implements ItemListener {
      public void itemStateChanged(ItemEvent tapahtuma)
      {
         JChoice valinta = (JChoice) tapahtuma.getItemSelectable();

         if (valinta.getSelectedIndex() == oikea_vastaus[1])
            showStatus("Valitsit oikean vastauksen (" +
                       valinta.getSelectedItem() + ")");
         else
            showStatus("Valitsit vrn vastauksen! (" +
                        valinta.getSelectedItem() + ")");
      }
   }
}
