/**
 * Luokka: Piste1D
 * Tekij: Juha Peltomki, 12.1998.
 * Aihe:   1D-pisteen ksittely.
           Luokan piste voi liikkua yksiulotteisesti
           rajoitetulla janalla.

 * Sislt metodit:
   * void siirra(lisattava)
   * void aseta(uusi_x)
   * String mjonoksi()
   * int arvo()
*/

class Piste1D {

/* Suojatut, luokan jsenmuuttujat eli ominaisuudet */
  private int arvo;
  private int min=0, max=640;

/* Luokan alustajat */

  Piste1D(int alkuarvo)
  {
    aseta(alkuarvo);
  }

  Piste1D(int alkuarvo, int minimi, int maksimi)
  {
    aseta(alkuarvo);
    if (min > max) {
      min  = minimi;
      max  = maksimi;
    }
  }

/* Luokan metodit */

  public void aseta(int uusi_arvo)
  {
    if (uusi_arvo >= min && uusi_arvo <= max) {
       arvo = uusi_arvo;
     }
     else
      System.out.println();
  }

  public void siirra(int lisattava)
  {
    if ( (arvo + lisattava) >= min &&
         (arvo + lisattava) <= max)
    {
       arvo += lisattava;
    }
  }

  public String mjonoksi() {
    return "" + this.arvo;
  }

  public int arvo() { return this.arvo; }

 }

/**
 * Luokka: Piste2D.java
 * Tekij: Juha Peltomki, 12.1998.
 * Aihe: Kaksiulotteinen piste. Kytetn yksiulotteisia
         pisteit luokan olioina. Tllin luokassa ei tarvita
         lainkaan uusia ominaisuuksia.

 * Sislt metodit:
   * void siirra(siirto_x, siirto_y)
   * void aseta(alku_x, min_x, max_x, alku_y, min_y, max_y)
   * String mjonoksi()
*/

/*
*/

class Piste2D
{
  private Piste1D x, y;

  Piste2D(int alku_x, int alku_y)
  {
    x = new Piste1D(alku_x, 0, 640);
    y = new Piste1D(alku_y, 0, 480);
  }

  Piste2D(int alku_x, int min_x, int max_x,
          int alku_y, int min_y, int max_y)
  {
    x = new Piste1D(alku_x, min_x, max_x);
    y = new Piste1D(alku_y, min_y, max_y);
  }

  public void aseta(int uusi_x, int uusi_y)
  {
    x.aseta(uusi_x);
    y.aseta(uusi_y);
  }

  public void siirra(int siirto_x, int siirto_y)
  {
    x.siirra(siirto_x);
    y.siirra(siirto_y);
  }

  public String mjonoksi()
  {
    return "(" + x.arvo() + "," + y.arvo() + ")" ;
  }
}
/* Testataan pisteluokka */

public class Piste2DTesti {

public static void main(String[] args)
   {
      Piste2D p1 = new Piste2D(100, 200);
      System.out.println(p1.mjonoksi());
      p1.siirra(200,200);
      System.out.println(p1.mjonoksi());
      p1.siirra(-250,250);
      System.out.println(p1.mjonoksi());

      // Tm pysytt tulostuksen JBuilderissa. VOI POISTAA MYHEMMIN!
      try {
         System.out.print("Lopeta>"); int koe = System.in.read();
      } catch (java.io.IOException ioe) { }
      // *************************************************
   }
}


