import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import java.awt.image.*;
import java.net.*;

public class KuvaAnimaatio extends Applet
{
   Image kuva[];      // Kuvat
   String tiedosto[]; // kuvien nimet
   int vuoro = 0;     // Mik kuva on vuorossa.
   int kuvia = 3;     // kuvien lukumr.
   MediaTracker mt;   // MediaTracker -luokan kytt.
   AnimaatioSaie saie;// Animaation hoitava sie.

   public void init()
   {
     tiedosto = new String[kuvia];
     kuva = new Image[kuvia];
     tiedosto[0] = "ukko1.gif";
     tiedosto[1] = "ukko2.gif";
     tiedosto[2] = "ukko3.gif";

   //  Ladataan kaikki kuvat MediaTracker-luokan olioon.
     mt = new MediaTracker(this);
     try {
       for (int i=0; i<kuvia; i++) {
         kuva[i] = getImage(getDocumentBase(), tiedosto[i]);
         mt.addImage(kuva[i], i);
       }
       mt.waitForAll();
     }
     catch (Exception kesk_poikkeus) {
       System.out.println("Poikkeusviesti: " + kesk_poikkeus.toString());
     }

     // Alustetaan ja aloitetaan animaation toteuttava sie.
     saie = new AnimaatioSaie(this, 300);
     saie.start();
   }

   /* Piirretn vuorossa oleva kuva. */
   public void paint(Graphics piirtopinta)
   {
     if (kuva[0] != null)
     {
       piirtopinta.drawImage(kuva[vuoro], 0, 0, this);
       if (vuoro < kuvia-1)
         vuoro++;
       else
         vuoro = 0;
      }
   }

   /* Ilman update-metodia animaatiossa esiintyy
      enemmn hiritsev vlkkymist.
   */
   public void update(Graphics piirtopinta) {
     paint(piirtopinta);
   }

}

/* Luodaan sie-luokka erikseen.
   Luokka hoitaa kytnnss kuvan piirtmisen
   kutsumalla applet-luokasta perityn appletin paint()-metodia.
   Kuva piirretn sikeen run()-metodissa uudestaan joka kierros.
*/

class AnimaatioSaie extends Thread
{
  KuvaAnimaatio appletti;
  int viive;

  /* Alustajametodi. */
  public AnimaatioSaie(KuvaAnimaatio a, int v) {
    aseta_appletti(a);
    aseta_viive(v);
  }

  /* Asetetaan parametrin tuotu appletti. */
  private void aseta_appletti(KuvaAnimaatio a)
  {
    this.appletti = a;
  }

  /* Asettaa animaation viiveen suuruuden. */
  public void aseta_viive(int v)
  {
    this.viive = v;
  }

  /* Sikeen ajaminen. */
  public void run() {
    while (true && this != null) {
      try {
        sleep(viive);
        appletti.repaint();
      }
      catch (Exception poikkeus) {
        System.out.println("Poikkeusviesti: " + poikkeus.toString());
      }
    }
  }
}
