import java.awt.*;
import java.applet.*;
import java.awt.event.*;

/**
  Tiedosto: MessageBox.java
  Tekij:   Juha Peltomki, 12.1998.
  Aihe:     Oman dialogin rakentaminen.
  Toiminta:
    Luokassa luodaan oma dialogi, jossa on voi olla joko yksi tai kaksi
    painiketta (Button). Tt dialogia ei voi poistaa nytlt ennenkuin
    valinta on tehty! Kyseess on ns. modaalinen dialogi, joka kaappaa kaikki
    iti-ikkunalle menevt sytteet itselleen.

  * MsgBox(Frame kehys, String viesti, boolean luo_peruuta) -
    Alustajametodilla luodaan kehys (Frame), jossa voi olla 1 tai 2 painiketta.
  * void aseta_kehys() - asettaa uuden kehyksen paikan.
  * void lisaa_painikkeet(boolean luo_peruuta) - Luo ja lis painikkeet kehykseen.
  * void lisaa_painike(Button painike, Panel paneeli) - Lis uuden painikkeen paneeliin.
  * boolean hyvaksytty() - palauttaa true, jos kyttj hyvksyi vastauksen.
*/

class MsgBox extends Dialog
{
  boolean id;
  private Button hyvaksy, peruuta;
  Panel paneeli;

  /* Alustajametodi. */
  MsgBox(Frame kehys, String viesti, boolean luo_peruuta)
  {
    super(kehys, "Viesti", true);
    setLayout(new BorderLayout());
    add("Center", new Label(viesti));
    lisaa_painikkeet(luo_peruuta);
    aseta_kehys();
    pack();
    id = false;
    setVisible(true);
  }

  public void aseta_kehys()
  {
    Dimension mitat = getToolkit().getScreenSize();
    setLocation(mitat.width/4, mitat.height/4);
  }

  public void lisaa_painikkeet(boolean luo_peruuta)
  {
    paneeli = new Panel();
    paneeli.setLayout(new FlowLayout());
    hyvaksy = new Button("Hyvksy");
    lisaa_painike(hyvaksy, paneeli);
    peruuta = new Button("Peruuta");
    if (luo_peruuta == true)
      lisaa_painike(peruuta, paneeli);
    add("South", paneeli);
  }

  public void lisaa_painike(Button painike, Panel paneeli)
  {
//    painike = new Button(nimike);
    paneeli.add(painike);
    painike.addActionListener(new PainikeKasittelija());
  }

  public boolean hyvaksytty()
  {
    return id;
  }

  /* Luokka ksittelee painikkeiden tapahtumat. */
  class PainikeKasittelija implements ActionListener
  {
    public void actionPerformed(ActionEvent tapaht)
    {
      if (tapaht.getSource() == hyvaksy)
        id = true;
      setVisible(false);
    }
  }
}

/* Testaa MsgBox -luokkaa! */

public class MessageBox extends Applet
{
  MsgBox viesti; // mritelln MsgBox-luokan olio.
  public void init()
  {
    // Dialogin luominen.
    viesti = new MsgBox(new Frame(""), "Oletko Varma?", true);
    requestFocus();
    repaint();
    // Dialogin tuhoaminen.
    viesti.dispose();
  }

  public void paint(Graphics piirtopinta)
  {
   // Dialogin kytt.
    if (viesti.hyvaksytty())
      piirtopinta.drawString("Valinta hyvksytty!", 30, 50);
    else
      piirtopinta.drawString("Valinta peruutettu!", 30, 50);
  }
}
