/*
    VaihtoehtoTesti.java
    Esimerkiss kaksi kysymyst ja vaihtoehdot
    kahdella erilaisella komponentill:
    a) Radiopainikkeet. (CheckBoxGroup-luokan oliot)
    b) Pudotusvalikko. (Choice-luokan oliot)

    Esimerkki Appletista, joka on muunnettu
    Swing-kirjastoa kyttvksi ohjelmaksi.

    Tekij: Juha Peltomki, 11.1999.
*/

package fi.teknolit.swingmuunnos;

import java.awt.*;
// lisys -> kirjastot swing:n kyttmiseksi.
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;

public class VaihtoehtoTesti extends JApplet
{
   private JLabel kysymys1, kysymys2;
   // muunnos Checkbox -> JRadioButton
   private JRadioButton radio[] = new JRadioButton[4];
   // muunnos CheckboxGroup -> ButtonGroup
   private ButtonGroup radionapit;
   // muunnos Choice -> JListi
   private JList valinnat;
   // muunnos Panel -> Jpanel. listn toinen kehys sijoittelemisen helpottamiseksi
   private JPanel kehys1, kehys2;

   // oikeat vastauksen sisltv taulukko.
   private static final int oikea_vastaus[] = {2, 3};
   // Alustetaan kysymyksen_arvot.
   private String kehittaja[] = {"Nokia", "IBM", "Sun", "Compaq"};
   private String vuosiluku[] = {"1970", "1981", "1990", "1995"};

   public void init()
   {
     setBackground(Color.lightGray);

     // Luodaan radiopainikeryhm kysymyksineen.
     kysymys1  = new JLabel("Mik yhti kehitti Javan?");
     radionapit = new ButtonGroup();

     for (int i=0; i<radio.length; i++)
     {
       radio[i] = new JRadioButton(kehittaja[i], false);
       // muunnos -> listn ryhmn ()
       radionapit.add(radio[i]);
       radio[i].addItemListener(new RadioKuuntelija());
     }

     // Luodaan pudotusvalikkoryhm kysymyksineen.
     kysymys2  = new JLabel("Milloin ilmestyi ensimminen Java-kehitin?");
     // Muutos: JList-listan voi muodostaan merkkijonotaulukosta
     valinnat = new JList(vuosiluku);
     // muutos: listn nkyvien alkioiden lukumr ja montako
     // listasta voi valita
     valinnat.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
     valinnat.setVisibleRowCount(4);

     // Muunnos: ItemListener -> ListSelectionListener
     valinnat.addListSelectionListener(new ListaKuuntelija());

     // Sijoitetaan elementit paneeleihin kehys1 ja kehys2
     kehys1 = new JPanel();
     kehys1.setLayout(new GridLayout(5, 1));
     kehys1.add(kysymys1);
     for (int i=0; i<radio.length; i++)
       kehys1.add(radio[i]);

     kehys2 = new JPanel();
     kehys2.setLayout(new GridLayout(5, 1));
     kehys2.add(kysymys2);
     kehys2.add(valinnat);

     // lisys appletin piirtopinnalle
     getContentPane().add(kehys1, BorderLayout.NORTH);
     getContentPane().add(kehys2, BorderLayout.SOUTH);
  }

/* Luokka ksittelee radiopainikkeiden tapahtumat. Luokka tarkastaa,
   oliko kohdeolio sama kuin oikea vastaus (radio[3]).
*/
   class RadioKuuntelija implements ItemListener {
     public void itemStateChanged(ItemEvent tapahtuma)
     {
        JRadioButton kohde = (JRadioButton) tapahtuma.getSource();
        if (kohde == radio[oikea_vastaus[0]])
          showStatus("Oikein! valittu komponentti "
                     + kohde.getLabel() + ")");
        else
          showStatus("Vrin! valittu komponentti "
                     + kohde.getLabel() + ")");
     }
  }

  /* Luokka ksittelee listan valinnat. Trkein metodi on getSelectedIndex(),
     joka palauttaa valintalistan valitun alkion indeksinumeron.
  */
  // muunnos: ItemEvent -> ListSelectionEvent
  class ListaKuuntelija implements ListSelectionListener {
    public void valueChanged(ListSelectionEvent tapahtuma)
    {
       // muunnos: getSelectedValue() palauttaa valitun arvon
       String valinta = (String)valinnat.getSelectedValue();
       if (valinta.equals(new String(vuosiluku[oikea_vastaus[1]])))
          showStatus("Valitsit oikean vastauksen (" +
                     valinta + ")");
       else
          showStatus("Valitsit vrn vastauksen! (" +
                      valinta + ")");
     }
  }
}