/*********************************************************************

filter.java

Esimerkki kuvan suodattamisesta. Kuva suodatetaan vaiheittain mustaksi ja 
takaisin normaaliksi. Suodattimena kytetn RGBImageFilterist peritty 
AlphaFilter-luokkaa.

Tekij: Pekka Malmirae 2/1999

Muutoksia: 
	Appletti pivitetty Java 1.1 -mukaiseksi:
	* Sikeiden ksittelyss pivitetty turvallisemmaksi (poistettu deadlock-vaarat)
	
	11/1999, Pekka Malmirae

*********************************************************************/

import java.awt.*;
import java.applet.*;
import java.awt.image.*;

class AlphaFilter extends RGBImageFilter {
  
  int a;  

  public AlphaFilter(int arvo) 
  {
        canFilterIndexColorModel = true;
        a = arvo;
  }
     
  public int filterRGB(int x, int y, int rgb) { return a*0x1000000; }
}
 


public class filter extends Applet implements Runnable
{
  
  Thread saie;
  Image kuva, suodatettuKuva, puskuriKuva;
  Graphics puskuri;
  MediaTracker md = new MediaTracker(this);
  int i;
  boolean alas;

  public void init()
  {
    i =255;
    kuva = getImage(getDocumentBase(), "kuva.jpg");
    puskuriKuva = createImage(getSize().width, getSize().height);
    puskuri = puskuriKuva.getGraphics();
    alas = true; 
    md.addImage(kuva,0);
    try { md.waitForID(0); } catch (InterruptedException e) {}
  }

  public void start()
  {
      saie = new Thread(this);
      saie.start();
  }

  public void stop() { saie = null; }


  public void run()
  {
    Thread tamaSaie = Thread.currentThread();	

    while (true) {
       
       if (alas) { 
        if (i > 17) i -= 16; 
        else { i = 0; alas = false; }
       }
       else {
         if ( i < 238) i += 16;
         else { i = 255; alas = true; }
       } 

      suodatettuKuva = createImage(new FilteredImageSource(kuva.getSource(), new AlphaFilter(i)));
      md.addImage(suodatettuKuva, 1);
      try { md.waitForID(1); } catch (InterruptedException e) {}
      repaint();
      try {tamaSaie.sleep(100);}
      catch (InterruptedException e) {}
    }
  }

  public void update(Graphics g)
  {
     if (suodatettuKuva == null) return;
     puskuri.drawImage(kuva,0,0,this);
     puskuri.drawImage(suodatettuKuva, 0,0, this);
    
    paint(g);
  }

  public void paint(Graphics g)
  {
    g.drawImage(puskuriKuva, 0,0,this);
  }
}