/*********************************************************************

mato.java

Matopeli-appletin mato apuluokkineen.

Mato-luokan tarvitsemat luokat:
	* osa (madon osa, pallon muotoinen olio, tiedostossa mato.java)
	* karkki (madon ruoka, neli tai pallo, tiedostossa mato.java)

Tekij: Pekka Malmirae 2/1999

*********************************************************************/

import java.awt.*;
import java.util.Random;


/***********************************
**** karkki-luokka
***********************************/

class karkki
{
  private Random sat = new Random();
  private int x, y;
  private Color vari;

public karkki()
{
   x = java.lang.Math.abs(sat.nextInt() % 488);
   y = java.lang.Math.abs(sat.nextInt() % 320);
   if (java.lang.Math.abs(sat.nextInt() % 2) == 1) vari = Color.yellow; 
   else vari = Color.green;
}

public int annaX()   { return x; }
public int annaY()   { return y; }
public Color annaVari() { return vari; }
}

/******************************
**class osa
******************************/  

class osa
{
  private int x, y, suunta;
  

public osa(int nx, int ny, int nsuunta)
{
  x = nx; y = ny; suunta = nsuunta;
}

public int annaX()      { return x; }
public int annaY()      { return y; }
public int annaSuunta() { return suunta; }

public void asetaX(int uusiX) { x = uusiX; }
public void asetaY(int uusiY) { y = uusiY; }
public void asetaSuunta(int uusiSuunta) { suunta = uusiSuunta; }
}

/*******************************
** class mato
******************************/

public class mato
{
  public final int VASEN  = -2;
  public final int OIKEA = 2;
  public final int YLOS  = 1;
  public final int ALAS  = -1;
  
  private final int OSAN_KOKO = 13;
  private final int LEVEYS  = 38*OSAN_KOKO + 2;
  private final int KORKEUS = 25*OSAN_KOKO + 2;
  private final int MADON_MAXKOKO = 100;

  private int koko;
  private int x, y;
  public  osa osat[] = new osa[MADON_MAXKOKO];
  private int suuntaTieto[] = new int[MADON_MAXKOKO];
  private karkki herkku = new karkki();

public mato(int nx, int ny, int k)
{
    x = nx; y = ny; koko = k;
    for (int i=0;i<koko;i++) osat[i] = new osa(x-(OSAN_KOKO*i),y,OIKEA);
    for (int i=0;i<MADON_MAXKOKO;i++)   suuntaTieto[i] = 0;
}


public int annaX() { return osat[0].annaX(); }
public int annaY() { return osat[0].annaY(); }


public boolean onkoKuollut()
{
 if ((annaX() >= LEVEYS - OSAN_KOKO)  || (annaX() <= 0) || 
     (annaY() >= KORKEUS - OSAN_KOKO) || (annaY() <= 0)) return true;
  for (int i=1;i<koko;i++)
    if (annaX() == osat[i].annaX())
	if (annaY() == osat[i].annaY()) return true; 
  return false;
}

public int syo()
{ 
  int pisteet = 0;
  if ((annaX()+OSAN_KOKO >= herkku.annaX()) && (annaX() <= herkku.annaX()+8) && 
      (annaY()+OSAN_KOKO >= herkku.annaY()) && (annaY() <= herkku.annaY()+8))
  {
  	 kasva();
         if (herkku.annaVari() == Color.green) pisteet = 150;
         else pisteet = 100;       
         herkku = new karkki();
  }
  return pisteet;
}

public void kaanny(int suunta) { suuntaTieto[0] = suunta; }

private void kasva() 
{
     if (koko<MADON_MAXKOKO) {
       koko++;
      
       switch (osat[koko-2].annaSuunta()) {
          case OIKEA  : osat[koko-1] = new osa(osat[koko-2].annaX() -OSAN_KOKO, osat[koko-2].annaY(), OIKEA); break;
          case ALAS   : osat[koko-1] = new osa(osat[koko-2].annaX(), osat[koko-2].annaY()-OSAN_KOKO, ALAS);   break;
          case VASEN  : osat[koko-1] = new osa(osat[koko-2].annaX() +OSAN_KOKO, osat[koko-2].annaY(), VASEN); break;
          case YLOS   : osat[koko-1] = new osa(osat[koko-2].annaX(), osat[koko-2].annaY()+OSAN_KOKO, YLOS);   break;
       }
    }
}

public void liiku()
{
  for (int j=0;j<koko;j++) if (suuntaTieto[j]!=0) osat[j].asetaSuunta(suuntaTieto[j]);
  for (int i=99;i>0;i--) suuntaTieto[i] = suuntaTieto[i-1];    
    for (int i=0;i<koko;i++)
      switch (osat[i].annaSuunta()) {
        case OIKEA: osat[i].asetaX(osat[i].annaX()+OSAN_KOKO); break;
        case ALAS:  osat[i].asetaY(osat[i].annaY()+OSAN_KOKO); break;
        case VASEN: osat[i].asetaX(osat[i].annaX()-OSAN_KOKO); break;
        case YLOS:  osat[i].asetaY(osat[i].annaY()-OSAN_KOKO); break;
      }
}

private String toString(int nro) { return (""+nro); }

public void piirraMato(Graphics g)
{
    g.setColor(Color.orange);
    g.fillOval(annaX(),annaY(),OSAN_KOKO,OSAN_KOKO);
    g.setColor(Color.red);
    for (int i=1;i<koko;i++) g.fillOval(osat[i].annaX(),osat[i].annaY(),OSAN_KOKO,OSAN_KOKO);

    g.setColor(herkku.annaVari());
    if (herkku.annaVari() == Color.green) g.fillRect(herkku.annaX(), herkku.annaY(), 8,8); 
    else g.fillOval(herkku.annaX(), herkku.annaY(), 8,8);
}
}