/****************************************************************

tietovisa.java

Tietovisa-appletti, jossa kysymykset haetaan WWW-palvelimella 
sijaitsevasta tekstitietokannasta.

Tekij: Pekka Malmirae, 2/1999

Muutoksia:
	* Pivitetty Java 1.1:n mukaiseksi:
		* size -> getSize
		* Tapahtumanksittely pivitetty Adapter-luokkaa kyttvksi
		
	Pekka Malmirae, 11/1999

****************************************************************/


import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.net.*;


/*************************************
** kyselij-luokka
**************************************/

class kyselija
{
  int kysymyksia, nro;
  String kysymys[];
  String vastaus[];
  String vaihtoEhdot[][];
  Font teksti = new Font("Arial", Font.BOLD, 18);

  public kyselija(String kysymykset[], int lkm)
  {
    kysymyksia = lkm;
    kysymys = new String[kysymyksia];
    vastaus = new String[kysymyksia];
    vaihtoEhdot = new String[kysymyksia][3];
    nro = 0;

    for (int i=0;i<kysymyksia;i++)
    {
      kysymys[i] = "";
      vaihtoEhdot[i][0] = "a) ";
      vaihtoEhdot[i][1] = "b) ";
      vaihtoEhdot[i][2] = "c) ";
      vastaus[i] = "";
    } 

    tee_kysymykset(kysymykset);
  }


  void tee_kysymykset(String kys[])
  {
    for (int i=0;i<kysymyksia;i++)
    {

    String teksti = kys[i];
     
    int j = teksti.indexOf("|");
    kysymys[i] += teksti.substring(0,j); 
    teksti = teksti.substring(j+1);

    for (int k=0;k<3;k++)
    {
      j = teksti.indexOf("|");
      vaihtoEhdot[i][k] += teksti.substring(0,j);
      teksti = teksti.substring(j+1);
    }

    j = teksti.indexOf("|");
    vastaus[i] = teksti.substring(0, j);
    vastaus[i] = vastaus[i].trim();  // mahd. tyhjt pois
    }
  }

 
  void kysy(Graphics g) 
  {  
     g.setFont(teksti);
     if (kysymys[nro].length() > 35)
     {
       int i = 26;
       while (! kysymys[nro].substring(i,i+1).equals(" ") && i < kysymys[nro].length()) i++; 
       String teksti1 = kysymys[nro].substring(0,i);
       String teksti2 = kysymys[nro].substring(i+1); 
       g.drawString(teksti1, 35, 50);
       g.drawString(teksti2, 35, 70);
     }  
     else g.drawString(kysymys[nro], 35, 50);
     for (int i=0;i<3;i++) g.drawString(vaihtoEhdot[nro][i], 35, 90+20*i);
  }
  
}

/*********************************************************************
** tietovisa -luokka
**
** Ohjelma kynnist kyselijn ja pistelaskurin.
** Kyselij lukee tiedostosta kysymyksi ja vastauksia ja 
** tulostaa niit nyttn. Jos kyttj vastaa kysymyksiin oikein, 
** laskurin arvoa kasvatetaan.
**
**********************************************************************/

public class tietovisa extends Applet
{
  int Laskuri, kysymyksia;
  kyselija nero;
  String vastaus;
  Image Tausta, uusiPeli;
  Font fontti = new Font("Arial", Font.BOLD, 26);
  boolean Ladattu, visaLoppu;
  AudioClip juu, ei;
  String kysymysData[];

  URL URLin;
  InputStream is;
  BufferedInputStream bis;
  BufferedReader br;


  public void init()
  {
    Laskuri = 0;

    try  {
      URLin = new URL(getParameter("url"));

      try {
      	is = URLin.openStream();
	bis = new BufferedInputStream(is);
	br = new BufferedReader(new InputStreamReader(bis));
        String s = br.readLine();	 
        kysymyksia = s.length();
        kysymysData = new String[kysymyksia];

        for (int i=0; i<kysymyksia;i++) {
          try { kysymysData[i] = br.readLine(); } catch (IOException e4) {}
         }
         is.close();
      } catch (IOException e3) {}

    } catch (MalformedURLException e) {}


    nero = new kyselija(kysymysData, kysymyksia);

    Tausta = getImage(getCodeBase(), "tausta.jpg");
    Image KuvaMuistiin = createImage(getSize().width, getSize().height);
    Graphics KuvaMuistiinKP = KuvaMuistiin.getGraphics();
    KuvaMuistiinKP.drawImage(Tausta, 0,0, this);

    uusiPeli = getImage(getCodeBase(), "uusivisa.jpg");
    Image KuvaMuistiin2 = createImage(getSize().width, getSize().height);
    Graphics KuvaMuistiinKP2 = KuvaMuistiin2.getGraphics();
    KuvaMuistiinKP2.drawImage(uusiPeli, 0,0, this);
    
    
    visaLoppu = false;
    Ladattu = false;
    juu = getAudioClip(getCodeBase(), "juu.au");
    ei = getAudioClip(getCodeBase(), "ei.au");
    addMouseListener(new HiiriKuuntelee()); 
  }

  void tee_tulos()
  {
   if (vastaus.compareTo(nero.vastaus[nero.nro]) == 0 && !visaLoppu) 
   {
      Laskuri++;
      juu.play();
   }
   else if (!visaLoppu) ei.play();
   if (nero.nro == kysymyksia-1) visaLoppu = true;
   nero.nro++;
   repaint();
  }

  public void update(Graphics g)
  {
    paint(g);
  }

  public void paint(Graphics g)
  {
    if (Ladattu) 
    {
      g.drawImage(Tausta, 0,0,this);
      showStatus("Valmis!");
    }
    else { showStatus("Ladataan grafiikkaa..."); return; }
    g.setFont(fontti);
    g.drawString(""+ Laskuri + "/" + nero.nro , 154, 249);

    if (!visaLoppu) nero.kysy(g); 
    else {
       g.drawString("Visa pttyi!", 50 ,50);
       g.drawImage(uusiPeli, 50, 70, this);
    }
  }

  class HiiriKuuntelee extends MouseAdapter
  {
    public void mousePressed(MouseEvent me) {
    int x = me.getX();
    int y = me.getY();
    if ((y >= 167) && (y <= 215))
    {
      if ((x >= 55) && (x <= 140))
      {
         vastaus = "a";  
         tee_tulos();
         return;
      }
      if ((x >= 167) && (x <= 250))
      {
         vastaus = "b";  
         tee_tulos();
         return;
      }
      if ((x >= 282) && (x <= 363))
      {
        vastaus = "c";  
        tee_tulos();
        return;
      }
    }

    if (visaLoppu && x>=50 && x<=202 && y>=70 && y<=131)
      {
         nero = new kyselija(kysymysData, kysymyksia);
         Laskuri = 0;
         visaLoppu = false;
         repaint();
      }
    }
  }
  

  public boolean imageUpdate(Image img, int infoflags, int x, 
			int y, int w, int h)
  {
    if (infoflags == ALLBITS)
    {
      Ladattu = true;
      repaint();
      return false;
    }
    else return true;
  }

}




