/***************************************************************
lauta.java

Tyhj Ruutu -pelin lauta-luokka ja sen kortti-apuluokka.

Tekij: Pekka Malmirae, 2/1999

***************************************************************/

import java.awt.*;
import java.util.Random;

/***************************************************************
Kortti
***************************************************************/

class kortti
{
  int x, y;
  Image kuva;
  int index;
  public kortti(int nx, int ny, Image image, int i)
  {
    asetaX(nx);
    asetaY(ny);
    asetaKuva(image);
    asetaPaikka(i);
  }

  public void asetaX(int arvo) {
    x = arvo;
  }
  
  public void asetaY(int arvo) {
    y = arvo;
  }

  public void asetaKuva(Image im) {
    kuva = im;
  }

  public void asetaPaikka(int p) {
    index = p;
  }

  public int X() { return x; }
  public int Y() { return y; }
  public int PAIKKA() { return index; }
  public Image KUVA() { return kuva;   }
}


/***************************************************************
Lauta
***************************************************************/

class lauta
{
  kortti Kuva[] = new kortti[10];
  int varatut[] = {-1,-1,-1,-1,-1,-1,-1,-1, -1};
  Random sat = new Random();
  boolean jarjestyksessa = false;

  public lauta(Image image[])
  {
    tee_paikat(image);
  }

  void tee_paikat(Image im[])
  {
    for (int i=0;i<9;i++) 
    {
      int luku = arvo_paikka();
      Kuva[i] = new kortti((i%3)*150+5, (i/3)*113+5, im[luku], luku); 
    }
      Kuva[9] = new kortti(0,0, im[9], 9);
  }

  int arvo_paikka()
  {
    int luku = java.lang.Math.abs(sat.nextInt() % 9);
    while (varatut[luku] == 0) luku = java.lang.Math.abs(sat.nextInt() % 9);
    varatut[luku] = 0;
    return luku;
  }

  public boolean siirra(int x, int y)
  {
    int nro = 10;
    int i;
    for (i=0; i<9;i++)
      if ((Kuva[i].X() < x) && (x < Kuva[i].X() + 150))
        if ((Kuva[i].Y() < y) && (y < Kuva[i].Y() + 113)) 
          { 
            nro = i;
            if (Kuva[i].PAIKKA() == 8) return false;
            break;     
          } 
    if (nro == 10) return false;
    
    if (nro<6) 		// Onko tyhj alapuolella  
      if (Kuva[nro+3].PAIKKA() == 8) 
       {vaihda(nro, nro+3); return true;}       
    
    if (nro>2)		// Onko tyhj ylpuolella
       if (Kuva[nro-3].PAIKKA() == 8)
        {vaihda(nro, nro-3); return true;} 
    
    if (nro == 0 || nro == 1 || nro == 3 || nro == 4 || nro == 6 || nro == 7)  // Onko oikealla
       if (Kuva[nro+1].PAIKKA() == 8)
          { vaihda(nro, nro+1); return true; }

    if (nro == 1 || nro == 2 || nro == 4 || nro == 5 || nro == 7 || nro == 8)  // Onko vasemmalla
       if (Kuva[nro-1].PAIKKA() == 8)
          { vaihda(nro, nro-1); return true; }
    
  return false;
  }

  void vaihda(int luku1, int luku2)
  {
      int apu;
  
      Kuva[9].asetaKuva(Kuva[luku2].KUVA());  
      Kuva[luku2].asetaKuva(Kuva[luku1].KUVA());      
      Kuva[luku1].asetaKuva(Kuva[9].KUVA()); 

      apu = Kuva[luku1].PAIKKA();
      Kuva[luku1].asetaPaikka(Kuva[luku2].PAIKKA());
      Kuva[luku2].asetaPaikka(apu);
  }

  void onko_jarjestyksessa()
  {
    for (int i=0;i<8;i++)
    {
       if (Kuva[i].PAIKKA() > Kuva[i+1].PAIKKA()) 
       {
          jarjestyksessa = false;
          return;
       }
    }
    jarjestyksessa = true;
  }
}
